<?php
namespace {
}



namespace XELOS\Modules\ApiMicrosoft{

	/**
	 * Class ApiMicrosoftController
	 * @package XELOS\Modules\ApiMicrosoft
	 */
	class ApiMicrosoftController extends \XELOS\Framework\Module\Controller implements \XELOS\Framework\Core\Interfaces\ModuleInterface
	{



	}
} 

namespace XELOS\Modules\ApiMicrosoft\Model{

	/**
	 * @property int user_id
	 * @property int document_index_id
	 * @property int drive_item_id
	 * @property int subscription_id
	 * @property string share_link_url
	 */
	class Subscription extends \XELOS\Framework\Module\Model\Model
	{

		/**
			 * @var \XELOS\Modules\ApiMicrosoft\ApiMicrosoftController
			 */
		public $mod;

		 
		public $model_version;

		 
		protected $table_auto_properties;

		 
		public $table_name;

		 
		protected $table_use_group_id;



	}
} 

namespace XELOS\Modules\ApiMicrosoft\Hook\ApiCloudstorage{

	/**
	 * Class OnedriveBusinessStorageProvider
	 *
	 * @package XELOS\Modules\ApiMicrosoft\Hook\ApiCloudstorage
	 */
	class OnedriveBusinessStorageProvider extends \XELOS\Modules\ApiMicrosoft\Hook\ApiCloudstorage\OnedriveStorageProvider
	{



		/**
			 * Returns a name identifier of the provider storage service.
			 *
			 * @return string
			 */
		public function get_provider_name(){}

		/**
			 * Returns the title of the provider storage service.
			 *
			 * @return string
			 */
		public function get_provider_title(){}

		/**
			 * @return bool
			 */
		public function hideWhenDisconnected(){}

		/**
			 * @inheritdoc
			 */
		public function init_provider(){}

		/**
			 * Returns true if this hook is available otherwise false.
			 *
			 * @return bool
			 */
		public function isAvailable(){}

	}

	/**
	 * Class OnedriveStorageProvider
	 *
	 * @package XELOS\Modules\ApiMicrosoft\Hook\ApiCloudstorage
	 */
	class OnedriveStorageProvider extends \XELOS\Modules\ApiCloudstorage\Hook\StorageProvider
	{

		/** @var \Microsoft\Graph\Model\Drive */
		protected $drive;

		/** @var \Microsoft\Graph\Graph */
		protected $graph;

		/** @var \XELOS\Modules\ApiMicrosoft\ApiMicrosoftController */
		public $mod;



		/**
			 * Delete the driveItemId from OneDrive
			 *
			 * This can fail for many many reasons (e.g. existing sharing link)
			 *
			 * @param string $driveItemId
			 *
			 * @return bool
			 */
		public function deleteDriveItem($driveItemId){}

		/**
			 * Download the requested remote file and save the content to temp path
			 *
			 * @param string $driveItemId
			 *
			 * @return bool|string path to file
			 */
		public function downloadDriveItem($driveItemId){}

		/**
			 * Returns size in bytes of total space of the storage.
			 *
			 * @return int
			 */
		public function get_account_quota_total(){}

		/**
			 * Returns size in bytes of used space of the storage.
			 *
			 * @return int
			 */
		public function get_account_quota_used(){}

		/**
			 * Returns an instance of StorageContent that contains
			 * all files requested by the given path which is provider specific
			 * .
			 *
			 * @param string $path A provider specific remote file path.
			 *
			 * @return \XELOS\Modules\ApiCloudstorage\Lib\StorageContent
			 */
		public function get_content($path){}

		/**
			 * Returns the xelos icon class name which presents
			 * the provider storage service.
			 *
			 * @return string
			 */
		public function get_icon_class_name(){}

		/**
			 * Returns a name identifier of the provider storage service.
			 *
			 * @return string
			 */
		public function get_provider_name(){}

		/**
			 * Returns the title of the provider storage service.
			 *
			 * @return string
			 */
		public function get_provider_title(){}

		/**
			 * @inheritdoc
			 */
		public function init_provider(){}

		/**
			 * Returns true if this hook is available otherwise false.
			 *
			 * @return bool
			 */
		public function isAvailable(){}

		/**
			 * Returns true if the provider is connected.
			 *
			 * @return bool
			 */
		public function is_connected(){}

		/**
			 * Returns an array which contains the content of the
			 * requested path. This array is used by xui_tree.
			 *
			 * @param string $path A provider specific remote file path.
			 *
			 * @return array
			 */
		public function on_browse_tree($path = NULL){}

		/**
			 * Download the requested remote file and save the content to
			 * the destination path.
			 *
			 * @param string $cloud_source_path
			 * @param string $destination_dir_path
			 *
			 * @return bool
			 */
		public function on_download($cloud_source_path, $destination_dir_path){}

		/**
			 * Executes the provider specific file upload from xelos
			 * to the remote storage space.
			 *
			 * @param string   $cloud_path
			 * @param string   $fileName
			 * @param resource $fileStream
			 *
			 * @return bool
			 */
		public function on_upload($cloud_path, $fileName, $fileStream){}

		/**
			 * Executes the provider specific file upload from xelos
			 * to the remote storage space.
			 *
			 * @param string   $fileName
			 * @param resource $fileStream
			 *
			 * @return false|array
			 */
		public function uploadAndCreateLink($fileName, $fileStream){}

	}
} 

namespace XELOS\Modules\ApiMicrosoft\Hook\Doclink{

	/**
	 * Class CoAuthorDocumentProcessor
	 * @package XELOS\Modules\ApiCloudstorage\Hook\Doclink
	 */
	class CoAuthorDocumentProcessor extends \xm_doclink_processor
	{

		/**
			 * @var \XELOS\Modules\ApiCloudstorage\ApiCloudstorageController
			 */
		protected $apiCloudStorage;

		/**
			 * @var \XELOS\Modules\ApiMicrosoft\ApiMicrosoftController
			 */
		public $mod;

		/** @var \XELOS\Modules\ApiMicrosoft\Hook\ApiCloudstorage\OnedriveBusinessStorageProvider */
		protected $oneDriveStorageProvider;



		/**
			 * @param \XELOS\Modules\ApiMicrosoft\Model\Subscription $subscription
			 *
			 * @return bool
			 */
		private function deletefromCloud(\XELOS\Modules\ApiMicrosoft\Model\Subscription $subscription){}

		/**
			 * @param \XELOS\Framework\XF\System\Model\DocumentIndex $document_index
			 *
			 * @return bool
			 */
		private function downloadFromCloud(\XELOS\Framework\XF\System\Model\DocumentIndex $document_index, \XELOS\Modules\ApiMicrosoft\Model\Subscription $subscription){}

		/**
			 * Returns action if any cloud service is registered in the cloud service manager.
			 * If there're no registered cloud provider, this method returns false.
			 *
			 * @param string        $id
			 * @param \XELOS\Framework\XF\System\Model\DocumentIndex $document_index
			 *
			 * @return bool|array
			 */
		public function get_action($id, $document_index = NULL){}

		/**
			 * Adds new share action on init.
			 *
			 */
		public function init(){}

		/**
			 * @param \XELOS\Framework\XF\System\Model\DocumentIndex $document_index
			 *
			 * @return array|false
			 */
		private function moveToCloudAndCreateShareLink(\XELOS\Framework\XF\System\Model\DocumentIndex $document_index){}

		/**
			 * put your comment there...
			 *
			 * @param \XELOS\Framework\XF\System\Model\DocumentIndex $document_index
			 * @param mixed         $action_status
			 * @param mixed         $direct_show
			 * @param string|bool   $keyname
			 *
			 * @return \xelos_global_template|array
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function on_trigger_action(\XELOS\Framework\XF\System\Model\DocumentIndex $document_index, $action_status = false, $direct_show = false, $keyname = false){}

	}
} 

namespace XELOS\Modules\ApiMicrosoft\Hook\System{

	class AzureAuthentication extends \XELOS\Framework\Module\Hook\AuthenticationHook implements \XELOS\Framework\Core\Authentication\AuthenticationInterface
	{

		 
		protected $auth_title;

		 
		private static $cookie_name = 'A_AZURE';

		 
		private $debug_mode;



		/**
			 * @throws \League\OAuth2\Client\Provider\Exception\IdentityProviderException
			 */
		public function afterLogin(){}

		/**
			 * @desc Return module information for authentication setup --> See systemadmin/authentication/
			 * @inheritdoc
			 * @throws \Exception
			 */
		public function getConfigurationFDL(){}

		/**
			 * Show this authentication method if installed, even if its not configured yet
		
			 * @return bool
			 */
		public function isAvailable(){}

		/**
			 * Check wether this Auth method should be used for the current request or not
			 * @return bool true if Auth method should be used and is available
			 */
		private function is_available(){}

		/**
			 * @inheritdoc
			 * @throws \Exception
			 */
		public function login($login, $password = NULL){}

		/**
			 * @return void
			 */
		public function logout(){}

	}
} 

namespace XELOS\Modules\ApiMicrosoft\Hook\Webservice{

	/**
	 * Class MicrosoftOauthClient
	 *
	 * @package XELOS\Modules\ApiMicrosoft\Hook\Webservice
	 */
	class MicrosoftOauthClient extends \XELOS\Modules\Webservice\Hook\OAuthClientHook
	{

		 
		protected $description;

		 
		protected $endpoint;

		 
		protected $icon_class;

		 
		protected $max_global_connections;

		 
		protected $max_user_connections;

		/** @var \XELOS\Modules\Webservice\Lib\OAuthClient */
		private $oauthClient;

		 
		protected $scope;

		 
		protected $title;

		/** @var \Microsoft\Graph\Model\User */
		private $userResource;



		/**
			 * @param \XELOS\Modules\Webservice\Lib\OAuthClient $client
			 *
			 * @return bool
			 */
		public function checkClientAfterAuthorization(\XELOS\Modules\Webservice\Lib\OAuthClient $client){}

		/**
			 * Return OAuthClient to Webservices
			 *
			 * @param null        $connection_fdl_result
			 * @param string|null $internal_redirect_url
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OAuthClient
			 */
		public function getOAuthClient($connection_fdl_result = NULL, $internal_redirect_url = NULL){}

		/**
			 * @inheritdoc
			 */
		public function isAllowedExplicitConnection(){}

		/**
			 * Returns true if this hook is available otherwise false.
			 *
			 * @return bool
			 */
		public function isAvailable(){}

		/**
			 * @param \XELOS\Modules\Webservice\Hook\OAuthClientHook $oauthClientHook
			 *
			 * @throws \Exception
			 */
		public function onBeforeSaveClient(\XELOS\Modules\Webservice\Hook\OAuthClientHook $oauthClientHook){}

	}

	/**
	 * Class OnedriveOauthClient
	 *
	 * @package XELOS\Modules\ApiMicrosoft\Hook\Webservice
	 */
	class OnedriveOauthClient extends \XELOS\Modules\Webservice\Hook\OAuthClientHook
	{

		 
		protected $client_id;

		 
		protected $description;

		 
		protected $endpoint;

		 
		protected $icon_class;

		 
		protected $max_global_connections;

		 
		protected $max_user_connections;

		/** @var \XELOS\Modules\Webservice\Lib\OAuthClient */
		private $oauthClient;

		 
		protected $scope;

		 
		protected $title;



		/**
			 * @inheritdoc
			 */
		public function checkClientAfterAuthorization(\XELOS\Modules\Webservice\Lib\OAuthClient $client){}

		/**
			 * @inheritdoc
			 */
		public function getOAuthClient($connection_fdl_result = NULL, $internal_redirect_url = NULL){}

		/**
			 * @inheritdoc
			 */
		public function init_service(){}

		/**
			 * @inheritdoc
			 */
		public function isAvailable(){}

	}
} 

