<?php
namespace {
}



namespace XELOS\Modules\Forum{

	/**
	 * ForumController Class
	 *
	 * @property-read \xm_crm_contactlog $contactlog
	 *
	 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\ForumControllerDocumentation
	 *
	 */
	class ForumController extends \XELOS\Framework\Module\Controller implements \XELOS\Framework\Core\Interfaces\ModuleInterface, \XELOS\Framework\Module\Controller\GroupControllerInterface
	{

		/** @var ForumController */
		public $mod;

		/** @var array */
		public $object_cache;

		/** @var \XELOS\Framework\XF\UI\Paging */
		public $paging;

		/** @var bool */
		public $policy_default_access;



		/**
			 * @desc this function is only for the groups module
			 */
		public function delete_group_context($group_id){}

		/**
			 * Create default category and thread
			 *
			 */
		public function ensure_initialization(){}

		/**
			 * @desc creates breadcrumb navigation for given obj
			 *
			 * @param \XELOS\Modules\Forum\Model\Post|\XELOS\Modules\Forum\Model\Thread|\XELOS\Modules\Forum\Model\Category|\XELOS\Framework\Module\Model\Model $obj
			 *
			 * @return string breadcrumb navigation
			 */
		public function get_breadcrumb(\XELOS\Framework\Module\Model\Model $obj){}

		/**
			 * @desc returns an array with id and pid for the dynamic part of the navigation
			 * @returns array dyn navigation
			 */
		public function get_dyn_tree(){}

		/**
			 * Guess the group ID by evaluating GP and CMD Vars
			 * @returns int Group ID
			 */
		public function guess_group_id($page_id, $args){}

		/**
		 * ForumController Class
		 *
		 * @property-read \xm_crm_contactlog $contactlog
		 *
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\ForumControllerDocumentation
		 *
		 */
		public function init(){}

		/**
			 * @desc Needed for Index Search
			 * @returns array
			 */
		public function resolve_doc_link($post_id, $post_type = false){}

		/**
			 * @inheritdoc
			 * @return bool|void
			 */
		public function send_file($args, $binary = false, $is_full_path = false){}

		/**
			 * Calculate used resources of this instance (by group_id if given)
			 * used in Groups Module
			 *
			 * @param int $group_id
			 *
			 * @return array -> ('raw_value'=>(double)raw_value,
			 *                   'raw_value_max'=>(double)max allowed value),
			 *                   'value'=>(string)formated string
			 *                   'value_max'=>(string)formated string
			 */
		public function used_resources($group_id = NULL){}

	}
} 

namespace XELOS\Modules\Forum\Model{

	/**
	 * Category Model
	 *
	 * @property string     type
	 * @property int        p_id
	 * @property Category[] sub_categories
	 * @property Thread[]   threads
	 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\CategoryDocumentation
	 * @method self find_by_p_id_and_group_id(int $int, int $group_context)
	 * @method self[]|\XELOS\Framework\Module\Model\ModelCollection find_all_by_group_id($group_id)
	 * @method self[]|\XELOS\Framework\Module\Model\ModelCollection  find_all_by_p_id(int $id)
	 * @method int count_by_group_id(int $group_id)
	 */
	class Category extends \XELOS\Framework\Module\Model\DocumentModel implements \XELOS\Framework\Core\Interfaces\SearchableDocumentModelInterface
	{

		/**
			 * @desc contains given values as array for fill_by_array
			 */
		protected $filled_by_array;

		/**
			 * @var \XELOS\Modules\Forum\ForumController
			 */
		public $mod;

		/**
			 * @desc indicates if post is a new one
			 */
		private $new;

		/**
			 * @desc this are the same properties as stored in the db
			 * @var array
			 */
		protected $properties;

		 
		protected $table_auto_properties;

		 
		public $table_name;

		 
		protected $table_use_group_id;



		/**
			 * @desc     Create Object
			 *
			 * @param int $category_id
			 */
		public function __construct($category_id = NULL){}

		/**
			 * Get Threads (internal function for more efficient usage
			 *
			 * @param int    $start                 Default:0
			 * @param int    $limit                 Default:ALL
			 * @param bool   $include_subcategories (will not be cached!)
			 * @param string $order_by
			 *
			 * @return \XELOS\Framework\Module\Model\ModelCollection|Thread[]
			 * @throws ContentException
			 * @throws \Exception
			 */
		private function _get_threads($start, $limit = NULL, $include_subcategories = false, $order_by = 'sorting_col DESC, last_reply_time DESC'){}

		/**
			 * Can moderate threads within this category
			 * @return array|bool
			 */
		public function can_moderate(){}

		/**
			 * Can create posts, edit own posts
			 * @return boolean
			 */
		public function can_post(){}

		/**
			 * Can read this category and its contents
			 * @return boolean
			 */
		public function can_read(){}

		/**
			 * Can create new categories or edit this category
			 * This is NOT can_post!
			 * @return array|bool
			 */
		public function can_write(){}

		/**
			 * @desc Delete category and all containing elements, there is no additional rights check!
			 *
			 * @param bool Don't rebuild the forum category tree: If false, a new category is created when all categories are
			 *                   deleted while rebuilding the tree.
			 *
			 * @inheritdoc
			 * @throws \Exception
			 */
		public function delete($skip_rebuild = false){}

		/**
			 * @desc returns an array of al categories accessable by the current user
			 *
			 * @param bool $restrict_to_this_category
			 *
			 * @return Category[]|\XELOS\Framework\Module\Model\ModelCollection
			 */
		public function get_all_accessible_categories($restrict_to_this_category = false){}

		/**
			 * @desc Dynamic Category Tree
			 * @returns array Tree of all Categories to be displayed in Navigation
			 */
		public function get_category_dyn_tree(){}

		/**
			 * @desc get info of containing threads: thread_count, category_count
			 * @return array post_info
			 * @throws \Exception
			 */
		public function get_category_info(){}

		/**
		 * Category Model
		 *
		 * @property string     type
		 * @property int        p_id
		 * @property Category[] sub_categories
		 * @property Thread[]   threads
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\CategoryDocumentation
		 * @method self find_by_p_id_and_group_id(int $int, int $group_context)
		 * @method self[]|\XELOS\Framework\Module\Model\ModelCollection find_all_by_group_id($group_id)
		 * @method self[]|\XELOS\Framework\Module\Model\ModelCollection  find_all_by_p_id(int $id)
		 * @method int count_by_group_id(int $group_id)
		 */
		public function get_is_empty(){}

		/**
			 * @desc returns parent object or false
			 * @return mixed object or false
			 */
		public function get_parent(){}

		/**
			 * @desc returns the last {count} recent posts
			 *
			 * @param int  $limit
			 * @param bool $include_subcategories
			 *
			 * @return array of post objects
			 * @throws ContentException
			 */
		public function get_recent_threads($limit = 10, $include_subcategories = true){}

		/**
			 * Get Accessible Sub Categories
			 * @return Category[]|\XELOS\Framework\Module\Model\ModelCollection
			 */
		public function get_sub_categories(){}

		/**
			 * Get Threads in this category
			 *
			 * @param int  $start Default:0
			 * @param int  $limit Default:ALL
			 * @param bool $cache Should result be cached?
			 *
			 * @param bool $include_subcategories
			 *
			 * @return Thread[]
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function get_threads($start, $limit = NULL, $cache = true, $include_subcategories = false, $order_by = NULL){}

		/**
			 * @return string Type Label [Idea,Question,Thread]
			 */
		public function get_type_label(){}

		/**
		 * Category Model
		 *
		 * @property string     type
		 * @property int        p_id
		 * @property Category[] sub_categories
		 * @property Thread[]   threads
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\CategoryDocumentation
		 * @method self find_by_p_id_and_group_id(int $int, int $group_context)
		 * @method self[]|\XELOS\Framework\Module\Model\ModelCollection find_all_by_group_id($group_id)
		 * @method self[]|\XELOS\Framework\Module\Model\ModelCollection  find_all_by_p_id(int $id)
		 * @method int count_by_group_id(int $group_id)
		 */
		public function get_user_id(){}

		/**
			 * @desc create links and assign to properties
			 */
		private function initialize_links(){}

		/**
			 * Mark all Threads from this category as read
			 *
			 * @throws \Exception
			 */
		public function mark_read(){}

		/**
			 * @inheritdoc
			 */
		public function onSearchIndexUpdate(\XELOS\Modules\Search\SearchIndexRecord $baseIndexRecord){}

		/**
			 * Re-calculate tree hierarchy.
			 *
			 * @throws \Exception
			 */
		private function rebuild_tree(){}

		/**
			 * @desc saves all values in db
			 * @throws \Exception
			 */
		public function save(){}

		/**
			 *
			 */
		public function update(){}

	}

	/**
	 * @property int thread_id
	 *
	 * @desc    Post Model
	 * @ingroup xm_forum
	 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
	 * @method int count_by_thread_id(int $id)
	 * @method Post find_by_thread_id(int $id, array $array)
	 * @method Post[] find_all_by_thread_id(int $id, array $array)
	 */
	class Post extends \XELOS\Framework\Module\Model\DocumentModel implements \XELOS\Framework\Core\Interfaces\SearchableDocumentModelInterface
	{

		/**
			 * @desc contains given values as array for fill_by_array
			 */
		protected $filled_by_array;

		/** @var \XELOS\Modules\Forum\ForumController */
		public $mod;

		 
		protected $model_default_render_xui;

		/**
			 * @desc indicates if post is a new one
			 */
		protected $new;

		/**
			 * @desc this are the same properties as stored in the db
			 * @var array
			 */
		protected $properties;

		 
		protected $table_auto_properties;

		 
		public $table_name;

		 
		protected $table_use_group_id;



		/**
			 * Batch-Calculate Post Counts for given threads
			 *
			 * @param \XELOS\Framework\Module\Model\ModelCollection|Thread[] $threads
			 *
			 * @return array|bool|mixed[]|\Returns
			 */
		public function calculatePostCountsForThreads(\XELOS\Framework\Module\Model\ModelCollection $threads){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function can_read(){}

		/**
			 * @return bool
			 */
		public function can_write(){}

		/**
			 * @desc deletes this post
			 */
		public function delete(){}

		/**
			 * @desc fills the object's properties with given assozitive array if propertiy is defined
			 *
			 * @param array values
			 */
		public function fill_by_array($values = array ( )){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function get_attachment_items($w = 100, $h = 100, $cropmode = 'crop'){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function get_category_id(){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function get_content_html(){}

		/**
			 * Returns the rendered doclink content or false
			 * @return bool|string
			 */
		public function get_doclink(){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function get_is_first_post_of_thread(){}

		/**
			 * @desc returns parent object or false
			 * @return Thread
			 */
		public function get_parent(){}

		/**
			 * @return string
			 */
		public function get_rendered_attachments(){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function get_reply_link(){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function get_user_id(){}

		/**
			 * @desc create all links if policies allows them
			 */
		private function initialize_links(){}

		/**
			 * this will check if the current post is the first post of its category
			 * @return boolean true on matching, else false
			 */
		public function is_first_post_of_thread(){}

		/**
			 * @inheritdoc
			 */
		public function onSearchIndexUpdate(\XELOS\Modules\Search\SearchIndexRecord $baseIndexRecord){}

		/**
			 * Save post
			 *
			 * @param bool $no_change Do not save as edited
			 *
			 * @return bool|int
			 * @throws \Exception
			 */
		public function save($no_change = false){}

		/**
		 * @property int thread_id
		 *
		 * @desc    Post Model
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\PostDocumentation
		 * @method int count_by_thread_id(int $id)
		 * @method Post find_by_thread_id(int $id, array $array)
		 * @method Post[] find_all_by_thread_id(int $id, array $array)
		 */
		public function set_content_html($text){}

		/**
			 *
			 */
		public function update(){}

	}

	/**
	 * @property string edit_link
	 * @property string delete_link
	 * @ingroup xm_forum
	 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\ThreadDocumentation
	 * @method find_all_by_category_id(int $id)
	 * @method count_by_category_id(int $id)
	 */
	class Thread extends \XELOS\Framework\Module\Model\DocumentModel implements \XELOS\Framework\Core\Interfaces\SearchableDocumentModelInterface
	{

		/** @var Post */
		private $_first_post;

		/**
			 * @desc contains given values as array for fill_by_array
			 */
		protected $filled_by_array;

		/** @var \XELOS\Modules\Forum\ForumController */
		public $mod;

		 
		protected $model_default_render_xui;

		/**
			 * @desc this are the same properties as stored in the db
			 * @var array
			 */
		protected $properties;

		 
		protected $table_auto_properties;

		 
		public $table_name;

		 
		protected $table_use_group_id;

		/**
			 * @desc set true for loading only the data for this object without all subcategories and threads
			 * @var boolean
			 */
		private $without_sub_objects;



		/**
			 * Can the current user read this thread?
			 * @return bool
			 */
		public function can_read(){}

		/**
			 * @return bool
			 */
		public function can_write(){}

		/**
			 * @desc delete this thread and all containing posts
			 */
		public function delete(){}

		/**
			 * Wrapper for First Post Attachments
			 * @return null|string
			 */
		public function get_attachments(){}

		/**
			 * Wrapper for First Post Content HTML
			 * @return null|string
			 */
		public function get_content_html(){}

		/**
			 * Wrapper for First Post Content PLAIN
			 * @return null|string
			 */
		public function get_content_plain(){}

		/**
			 * Get first post of thread (by created_at ASC)
			 * @return Post
			 */
		public function get_first_post(){}

		/**
			 * @desc Return category of this thread
			 * @return Category
			 */
		public function get_parent(){}

		/**
			 * Number of posts in this thread
			 * @return int
			 */
		public function get_post_count(){}

		/**
			 * Get Threads in this category
			 *
			 * @param int  $start Default:0
			 * @param int  $limit Default:ALL
			 * @param bool $cache Should result be cached?
			 *
			 * @return Post[]
			 */
		public function get_posts($start, $limit = NULL, $cache = true){}

		/**
			 * @desc returns the last {count} recent posts
			 *
			 * @param int  $count
			 * @param bool $include_first_post False = Do no return the first post
			 *
			 * @return Post[]
			 * @throws \Exception
			 */
		public function get_recent_posts($count = 10, $include_first_post = true){}

		/**
			 * put your comment there...
			 * @return \XELOS\Framework\Module\Model\ModelCollection<XELOS\Modules\Forum\Model\Post>
			 */
		public function get_related_posts(){}

		/**
			 * state should be required, but some models didn't save the state-field proper
			 * => default Fallback: state = open
			 *
			 * @todo modify if more states are available
			 * @todo split this field to -> open_flag[boolean] and sticky_flag[boolean]
			 * @return string [open DEFAULT, closed, sticky, sticky_closed]
			 */
		public function get_state(){}

		/**
		 * @property string edit_link
		 * @property string delete_link
		 * @ingroup xm_forum
		 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\ThreadDocumentation
		 * @method find_all_by_category_id(int $id)
		 * @method count_by_category_id(int $id)
		 */
		public function get_tags(){}

		/**
			 * @desc get info of containing posts: last_post_time, last_post_user, post_count
			 * @return array thread_info
			 */
		public function get_thread_info(){}

		/**
			 * Wrapper for standard model logic where user_id is the author, created_by is a historical naming not used anymore
			 * @return int
			 */
		public function get_user_id(){}

		/**
			 * @desc create links and assig to properties
			 */
		private function initialize_links(){}

		/**
			 * Is thread closed?
			 * @return boolean
			 */
		public function is_closed(){}

		/**
			 * Is thread sticky?
			 * @return boolean
			 */
		public function is_sticky(){}

		/**
			 * Mark thread as read
			 * @return mixed
			 */
		public function mark_read(){}

		/**
		 * @inheritdoc
		 */
		public function onSearchIndexUpdate(\XELOS\Modules\Search\SearchIndexRecord $baseIndexRecord){}

		/**
			 * Save thread
			 *
			 * @param bool $no_change Do not save as edited
			 *
			 * @return bool|int
			 * @throws \Exception
			 */
		public function save($no_change = false){}

		/**
			 *
			 * @throws \Exception
			 */
		public function update(){}

	}

	/**
	 * Class XELOS\Modules\Forum\Model\Votes
	 * @mixin \XELOS\Modules\Forum\Docs\ClassGenerated\Model\VotesDocumentation
	 *
	 * @method find_by_instance_id_and_thread_id_and_user_id($instance_id, $thread_id, $user_id)
	 */
	class Votes extends \XELOS\Framework\Module\Model\Model
	{

		/** @var bool */
		public $table_auto_properties;

		/** @var string */
		public $table_name;



		/**
			 * @param int $thread_id
			 *
			 * @return int
			 */
		public function get_vote_value($thread_id){}

	}
} 

namespace XELOS\Modules\Forum\Page{

	class DeletePage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Forum\ForumController */
		public $mod;



		public function get_page($type = false, $id = false){}

		/**
			 * @desc Delete the requested category, thread or post and shows it's parent
			 *
			 * @param bool $type
			 * @param bool $id
			 *
			 * @return void template
			 * @throws \Exception
			 */
		public function page_delete($type = false, $id = false){}

	}

	class EditPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Forum\ForumController */
		public $mod;



		/**
			 * this callback will call the parent-thread as the same name,
			 * if the current edited post is the first post of this thread
			 *
			 * @param \XELOS\Framework\XF\UI\Form $form
			 */
		public function edit_post_form_callback($form){}

		/**
			 * @param bool $type
			 * @param bool $id
			 *
			 * @return \XELOS\Framework\Core\Template|\xelos_global_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 * @throws \Exception
			 */
		public function get_page($type = false, $id = false){}

		/**
			 *
			 * @param \XELOS\Framework\XF\UI\Form $form
			 */
		public function new_thread_form_callback($form){}

		/**
			 * @param int $id
			 *
			 * @return \XELOS\Framework\Core\Template|\xelos_global_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 * @throws \Exception
			 */
		public function page_edit_category($id = NULL){}

		/**
			 * @param bool $id
			 * @param bool $new
			 *
			 * @return \XELOS\Framework\Core\Template|\xelos_global_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function page_edit_post($id = false, $new = false){}

		/**
			 * @param bool $id
			 * @param bool $new
			 *
			 * @return \XELOS\Framework\Core\Template|\xelos_global_template
			 * @throws \Exception
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function page_edit_thread($id = false, $new = false){}

	}

	class FeedPage extends \XELOS\Framework\Module\Page\Page
	{

		 
		protected $default_page;

		/** @var $mod ForumController $mod */
		public $mod;



		/**
			 * @desc Show Recent Articles as feed
			 *
			 * @param int $cat_id
			 *
			 * @return void
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function page_feed($cat_id = NULL){}

	}

	/**
	 * Class SetupPage
	 * @package XELOS\Modules\Forum\Page
	 */
	class SetupPage extends \XELOS\Framework\Module\Page\SetupPage
	{



		/**
		  * checks several points for being configured and returns an array with the checks and their results
		  * 
		  * @return array status details check->ok
		  */
		protected function get_configuration_steps(){}

		/**
		 * Class SetupPage
		 * @package XELOS\Modules\Forum\Page
		 */
		protected function get_setup_step($step){}

		/**
		 * Class SetupPage
		 * @package XELOS\Modules\Forum\Page
		 */
		private function has_root_category(){}

		/**
		 * Class SetupPage
		 * @package XELOS\Modules\Forum\Page
		 */
		protected function is_setup_step_finished($step){}

		/**
		 * Class SetupPage
		 * @package XELOS\Modules\Forum\Page
		 */
		private function page_categories(){}

		/**
		 * Class SetupPage
		 * @package XELOS\Modules\Forum\Page
		 */
		protected function user_has_access(){}

	}

	class ShowPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Forum\ForumController */
		public $mod;



		/**
			 * @param bool $type
			 * @param bool $id
			 *
			 * @return bool|object|string|\xelos_global_template|\XELOS\Framework\Core\Template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 * @throws \Exception
			 */
		public function get_page($type = NULL, $id = NULL){}

		/**
			 * Redirects the user to the main category page of this Form Instance
			 * @throws \Exception
			 */
		private function redirect_to_index(){}

		/**
			 * @desc Show Category
			 *
			 * @param int $id
			 *
			 * @return \XELOS\Framework\Core\Template template
			 * @throws ContentException
			 * @throws \Exception
			 */
		public function show_category($id){}

		/**
			 * @desc Show Thread
			 *
			 * @param bool $id
			 *
			 * @return object template
			 * @throws \Exception
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function show_thread($id = false){}

	}
} 

namespace XELOS\Modules\Forum\UI{

	/**
	 * Class ThreadPreview
	 *
	 * @package XELOS\Modules\Forum\UI
	 */
	class ThreadPreview extends \XELOS\Framework\Module\UI\Document
	{

		/** @var \XELOS\Modules\Forum\Model\Post|\XELOS\Modules\Forum\Model\Thread */
		protected $model;



		/**
			 * @return string
			 * @throws \Exception
			 */
		public function get_description(){}

		/**
			 * Render a preview of the thread
			 * @throws \Exception
			 */
		public function get_full_preview(){}

		/**
		 * Class ThreadPreview
		 *
		 * @package XELOS\Modules\Forum\UI
		 */
		public function get_image($w = false, $h = false, $cropmode = false){}

		/**
		 * Class ThreadPreview
		 *
		 * @package XELOS\Modules\Forum\UI
		 */
		public function get_title(){}

		/**
		 * Class ThreadPreview
		 *
		 * @package XELOS\Modules\Forum\UI
		 */
		public function init(){}

	}

	/**
	 * Class XELOS\Modules\Forum\UI\VoteBox
	 */
	class VoteBox extends \XELOS\Framework\Module\UI\UIAjaxComponent
	{

		/** @var array */
		protected $js_options;

		/** @var \XELOS\Modules\Forum\ForumController */
		public $mod;

		/** @var string */
		private $my_vote;

		/** @var bool */
		private $render_value_only;

		/** @var \XELOS\Modules\Forum\Model\Thread */
		private $thread;

		/** @var int */
		private $thread_id;

		/** @var int */
		private $vote_value;



		/**
			 * @return int
			 */
		public function get_vote_value(){}

		/**
			 *
			 */
		public function process_xui(){}

		/**
			 * Set rendering to value only and return the rendered
			 * content by parent class.
			 * @return bool|string|\XELOS\Framework\Core\Template
			 * @throws ContentException
			 */
		public function render_value(){}

		/**
			 *
			 */
		protected function render_xui(){}

		/**
			 * If this method is called, it will only render the vote value without
			 * the control elements.
			 *
			 * @param bool $bool
			 */
		public function set_render_value_only($bool = true){}

		/**
			 * Set Thread the vote is referecing
			 *
			 * @param \XELOS\Modules\Forum\Model\Thread $thread
			 */
		public function set_thread(\XELOS\Modules\Forum\Model\Thread $thread){}

		/**
			 * @param $id
			 */
		public function set_thread_id($id){}

		/**
		 * Class XELOS\Modules\Forum\UI\VoteBox
		 */
		public function set_vote_value($value){}

	}
} 

namespace XELOS\Modules\Forum\Hook\Groups{

	/**
	 * @desc Copy Structure, Data & Policies (Group-Template -> Group)
	 */
	class GroupsTemplateInit extends \xm_groups_template_init implements \xi_groups_template_init
	{

		/** @var \XELOS\Modules\Forum\ForumController */
		public $mod;



		/**
			 * [Extended]
			 *
			 * @param \XELOS\Framework\Module\Model\Model $model
			 *
			 * @return \XELOS\Framework\Module\Model\Model
			 */
		protected function clone_model($model){}

		/**
			 * @param int $src_post_id
			 * @param int $trg_post_id
			 */
		private function duplicate_files($src_post_id, $trg_post_id){}

		/**
			 * process
			 */
		public function process(){}

	}
} 

namespace XELOS\Modules\Forum\Hook\Portal{

	/**
	 * @desc PORTLET Forum Class
	 */
	class RecentShowPortlet extends \XELOS\Framework\Module\Hook\ModulePortlet
	{

		 
		public $meta_info;

		/** @var  \XELOS\Modules\Forum\ForumController */
		public $mod;



		/**
		 * @desc PORTLET Forum Class
		 */
		public function __construct(){}

		/**
			 * @see ModulePortlet
			 *
			 * @param bool $component_id
			 *
			 * @return mixed
			 * @throws \Exception
			 */
		public function get_fdl($component_id = false){}

		/**
			 * @see ModulePortlet
			 */
		public function get_html($size = 'default'){}

		/**
			 * Return Recent Threads
			 *
			 * @param array $cats
			 * @param int   $number
			 * @param array $group_ids
			 *
			 * @return string
			 */
		private function get_recent_posts($cats = array ( ), $number = 5, $group_ids = array ( )){}

		/**
		 * @desc PORTLET Forum Class
		 */
		public function init(){}

	}
} 

