<?php
namespace {
}



namespace XELOS\Modules\Lists{

	/**
	 * @mixin \XELOS\Modules\Lists\Docs\ClassGenerated\ListsControllerDocumentation
	 */
	class ListsController extends \XELOS\Framework\Module\Controller implements \XELOS\Framework\Core\Interfaces\ModuleInterface, \XELOS\Framework\Module\Controller\GroupControllerInterface
	{

		/**
			 * Use Folders to manage and display lists
			 * @var bool
			 */
		private $useFolders;



		/**
			 * Create a Payload for Workflows by Form-ID
			 *
			 * @param mixed $form_id
			 *
			 * @return object
			 */
		public function create_workflows_payload($form_id){}

		/**
			 * Makes sure a default category will be set with it's corresponding rights preset
			 *
			 * @throws \Exception
			 */
		public function ensure_initialization(){}

		/**
			 * @inheritdoc
			 */
		public function guess_group_id($page_id, $cmd_args){}

		/**
			 * @desc Initialization after Construct
			 * @throws \Exception
			 */
		public function init(){}

		/**
			 * @return bool
			 */
		public function isUseFolders(){}

		/**
			 * @desc Needed for Index Search
			 *
			 * @param int      $post_id
			 * @param int|bool $post_type
			 *
			 * @return array|false link array
			 */
		public function resolve_doc_link($post_id, $post_type = NULL){}

		/**
			 * @param bool $useFolders
			 *
			 * @return ListsController
			 */
		public function setUseFolders($useFolders){}

	}
} 

namespace XELOS\Modules\Lists\Action{

	class FormprocessorAction
	{

		 
		protected $fdl;

		 
		protected $field_id_index;

		 
		protected $formdata;

		/**
			 * Reference to XELOS\Modules\Lists\ListsController
			 *
			 * @var \XELOS\Modules\Lists\ListsController
			 */
		public $mod;

		 
		public $upload_dir;



		/**
			 * Add Field Data
			 *
			 * @param string $key internal key (e.g. 1hb976g18874)
			 * @param mixed  $data
			 */
		public function add_field_data($key, $data){}

		/**
			 * Add formdata to processor
			 *
			 * @param mixed $data
			 */
		public function add_formdata($data){}

		/**
			 * Get Formdata by field ID
			 *
			 * @param mixed $field_id
			 *
			 * @return mixed
			 */
		public function get_data_by_field_id($field_id){}

		/**
			 * Replace Placeholders in String
			 *
			 * @param string $haystack
			 *
			 * @return string
			 */
		public function replace_placeholders($haystack){}

		public function replace_placeholders_cb($search, $keep_unreplaced_markers = true){}

		/**
			 * @param array $fdl
			 */
		public function set_fdl($fdl){}

	}

	class FormprocessorEmailAction extends \XELOS\Modules\Lists\Action\FormprocessorAction
	{

		/** @var \XELOS\Modules\Lists\Model\ListProperties */
		private $form_model;



		/**
			 * Get attachments
			 *
			 * @return array
			 */
		public function get_attachments(){}

		/**
			 * Get rendered HTML email
			 *
			 * @return string
			 */
		public function get_html(){}

		/**
			 * Get Plaintext for Email
			 *
			 */
		private function get_plaintext(){}

		/**
			 * Replaces markers {field_id} in the subject
			 *
			 * @param mixed $subject
			 *
			 * @return mixed
			 */
		private function get_subject($subject){}

		/**
			 * Process
			 *
			 * @param \XELOS\Modules\Lists\Model\ListProperties $form_model
			 *
			 * @return bool success
			 */
		public function process(\XELOS\Modules\Lists\Model\ListProperties $form_model){}

	}

	/**
	 * Class XELOS\Modules\Lists\Action\FormprocessorWorkflowAction
	 * This Class will start the workflow for a list item
	 *
	 */
	class FormprocessorWorkflowAction extends \XELOS\Modules\Lists\Action\FormprocessorAction
	{



		/**
			 * Process
			 *
			 * @param \XELOS\Modules\Lists\Model\ListItem
			 *
			 * @return bool
			 * @throws \Exception
			 */
		public function process(\XELOS\Modules\Lists\Model\ListItem $list_item){}

	}
} 

namespace XELOS\Modules\Lists\Model{

	/**
	 * @desc    Form Model
	 * @author  Stefan Pasel
	 * @ingroup XELOS\Modules\Lists\ListsController
	 *
	 *
	 * @property int    $id
	 * @property int    $pid
	 * @property int    $group_id
	 * @property string $title      : stored in MySQL as varchar
	 * @property string $description: stored in MySQL as text
	 *
	 * @method Category find_by_id($id, $query_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|Category[] find_all_by_id($id, $query_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|Category[] find_all_by_pid(int $id)
	 * @mixin \XELOS\Modules\Lists\Docs\ClassGenerated\Model\CategoryDocumentation
	 */
	class Category extends \XELOS\Framework\Module\Model\Model
	{

		/**
			 * @var \XELOS\Modules\Lists\ListsController
			 */
		public $mod;

		 
		public $model_version;

		 
		protected $table_auto_properties;

		 
		public $table_name;

		 
		protected $table_use_group_id;



		/**
			 * Can read
			 *
			 * @return bool
			 */
		public function can_read(){}

		/**
			 * Can write
			 *
			 * @return bool
			 */
		public function can_write(){}

		/**
			 * Delete this category and all forms within
			 */
		public function delete(){}

		/**
			 * @param string $policyLevel 'read' or 'manage'
			 *
			 * @return array
			 */
		private function getAccessibleCategories($policyLevel = 'read'){}

		/**
			 * Get Categories which are considered managable to the current user
			 *
			 * @return \XELOS\Framework\Module\Model\ModelCollection|Category[]
			 */
		public function getManagableCategories(){}

		/**
			 * Get Categories which are considered readable to the current user
			 *
			 * @return \XELOS\Framework\Module\Model\ModelCollection|Category[]
			 */
		public function getReadableCategories(){}

		/**
			 * @desc Return category IDs with the policy
			 *
			 * @param string $policy_level Policy read, manage
			 *
			 * @returns bool|int[] TRUE if all categories have the policy, FALSE if none are accessible and an array if multiple
			 *          are accessible
			 * @return array|bool
			 */
		public function get_category_ids($policy_level = 'read'){}

	}

	/**
	 * Class XELOS\Modules\Lists\Model\ListProperties
	 *
	 * @property int    $id
	 * @property int    $numeric_id
	 * @property string $workflow_status
	 * @property int    $list_id
	 * @property int    group_id          Group ID
	 * @property int    $status_id
	 * @property string $unique_value
	 * @property string $form_data        : stored in MySQL as text
	 * @property string $facetted_1
	 * @property string $facetted_2
	 * @property string $facetted_3
	 * @property string $facetted_4
	 * @property string $facetted_5
	 *
	 * @property string $rights_check     enum hidden|read_assigned|read_all|edit_assigned|edit_all
	 * @property int    $user_id
	 * @property string $assigned_user_ids: stored in MySQL as text
	 * @property int    $created_at       : stored in MySQL as timestamp
	 * @property int    $updated_at       : stored in MySQL as timestamp
	 *
	 * @method ListItem find_by_id($id, $sql_params = false)
	 * @method ListItem find_by_id_and_list_id(int $id, int $list_id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_id($id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_list_id(int $list_id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_list_id_and_status_id(int $list_id, int $status_id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_id_and_list_id(int $id, int $list_id, $sql_params = false)
	 */
	class ListItem extends \XELOS\Framework\Module\Model\DocumentModel implements \XELOS\Framework\Core\Interfaces\SearchableDocumentModelInterface
	{

		/**
			 * @var ListProperties
			 */
		private $_list;

		/**
			 * @var \XELOS\Modules\Lists\ListsController
			 */
		public $mod;

		 
		protected $model_default_render_xui;

		 
		public $model_version;

		 
		protected $properties;

		 
		protected $table_auto_properties;

		 
		protected $table_name;

		 
		protected $table_use_group_id;



		/**
			 * Checks if the current user can read this list item.
			 * The user can read if:
			 *  - he can write OR
			 *  - he has the read policy and the status rights_check is read_all or if it's read_assigned and the user is assigned.
			 *
			 * @return bool
			 */
		public function can_read(){}

		/**
			 * Checks if the current user can write this list item.
			 * The user can write if:
			 *  - he is the author of the list OR
			 *  - he has the manage_list policy on the list OR
			 *  - he has the write_list policy and the status rights_check is edit_all or if it's edit_assigned and the user is assigned.
			 *
			 * @return bool
			 */
		public function can_write(){}

		/**
			 * count dooku
			 *
			 * @param string $uniqueFieldValue
			 *
			 * @param        $list
			 *
			 * @return bool
			 */
		private function checkForUniqueValue($uniqueFieldValue, $list){}

		/**
			 * Returns form_data decoded
			 * @return array ['FIELD_ID'=>'VALUE']
			 */
		public function getItemData(){}

		/**
			 * Get ItemData by type
			 *
			 * @param string $fieldType e.g. document
			 *
			 * @return array
			 */
		public function getItemDataByType($fieldType){}

		/**
			 * @return ListProperties
			 */
		public function getListProperties(){}

		/**
			 * Returns the form FDL to display a specific item or an empty form for this list
			 *
			 * @param ListProperties $list
			 * @param bool           $set_saved_values
			 * @param string         $show_only all|form|table|filter: Returns the FDL which has the show_in_xxx checkbox set or all.
			 * @param bool           $readonly
			 *
			 * @return array
			 */
		public function get_fdl($list = NULL, $set_saved_values = false, $show_only = 'form', $readonly = false){}

		/**
			 * Return "running" ID for this list item
			 *
			 * @param string $type  numeric|technical:
			 *                      - numeric counts all entries and returns the ID.
			 *                      - technical gives a base 35 string as the ID.
			 *
			 * @return string
			 */
		public function get_friendly_id($type = 'numeric'){}

		/**
			 * Returns the first two filled out fields in the list item.
			 * Used in the document viewer when linking an item.
			 *
			 * @return string
			 */
		public function get_title(){}

		/**
			 * Make list items searchable in central search
			 * @inheritdoc
			 */
		public function onSearchIndexUpdate(\XELOS\Modules\Search\SearchIndexRecord $baseIndexRecord){}

		/**
		 * Class XELOS\Modules\Lists\Model\ListProperties
		 *
		 * @property int    $id
		 * @property int    $numeric_id
		 * @property string $workflow_status
		 * @property int    $list_id
		 * @property int    group_id          Group ID
		 * @property int    $status_id
		 * @property string $unique_value
		 * @property string $form_data        : stored in MySQL as text
		 * @property string $facetted_1
		 * @property string $facetted_2
		 * @property string $facetted_3
		 * @property string $facetted_4
		 * @property string $facetted_5
		 *
		 * @property string $rights_check     enum hidden|read_assigned|read_all|edit_assigned|edit_all
		 * @property int    $user_id
		 * @property string $assigned_user_ids: stored in MySQL as text
		 * @property int    $created_at       : stored in MySQL as timestamp
		 * @property int    $updated_at       : stored in MySQL as timestamp
		 *
		 * @method ListItem find_by_id($id, $sql_params = false)
		 * @method ListItem find_by_id_and_list_id(int $id, int $list_id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_id($id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_list_id(int $list_id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_list_id_and_status_id(int $list_id, int $status_id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListItem[] find_all_by_id_and_list_id(int $id, int $list_id, $sql_params = false)
		 */
		public function resetFilterValues(){}

		/**
			 * Loops through all form fields and sets:
			 *  - the status_id of the list item if a list_status form element is in the form definition
			 *  - the assigned_user_ids of the list item if assigned_users form elements are defined in the form definition.
			 *    If new users are assigned, those new users are notified if the notification process action is activated in the
			 *    list.
			 *
			 * @return int
			 * @throws \Exception
			 */
		public function save(){}

		/**
			 * The list can be set to prevent an additional call to the database to access the list.
			 *
			 * @param ListProperties $list
			 */
		public function setListProperties(\XELOS\Modules\Lists\Model\ListProperties $list){}

		/**
			 * Fetches the fields from the list which should be displayed as filters and
			 * saves those values in the list item fields facetted_1 - facetted_5.
			 */
		private function updated_facetted_fields(){}

		/**
			 * Tests if the form_identifier is unique and if only 5 facetted fields are selected.
			 *
			 * @param array $fieldErrors
			 *
			 * @return bool
			 */
		public function validate($fieldErrors){}

	}

	/**
	 * Class XELOS\Modules\Lists\Model\ListProperties
	 *
	 * @property int    $id                       ID
	 * @property int    $user_id                  User ID
	 * @property int    $group_id                 Group ID
	 * @property int    $as_template              Is a template?
	 * @property int    $category_id              Category ID
	 * @property int    $active                   Active
	 * @property string $title                    Title
	 * @property string $list_type                standard, workflow, template
	 * @property string $form_identifier          Identifier
	 * @property string $form_type                Type [standalone|workflow]
	 * @property string $form_description         Description
	 * @property string $form_struct              Structure JSON encoded array of form fields
	 * @property int    $form_link                Form link for redirecting after form submits
	 * @property string $form_process             Processor [workflows]
	 * @property string $form_finish              Plain message after sending the form
	 * @property string $form_finish_html         HTML message after sending the form
	 * @property string $process_email_subject    Subject of form email
	 * @property string $process_email_recipients Recipients of form email
	 * @property string $process_db_storage_sql   Database storage SQL
	 * @property int    $process_workflow_id      Workflow ID
	 * @property int    $show_workflow_status     Shows the workflow status instead of the list status
	 * @property int    $item_count               Total items created for this list
	 * @property int    $created_at               Create date
	 * @property int    $updated_at               Last update date
	 * @property string $rights_check							enum: hidden|read_assigned|read_all|edit_assigned|edit_all
	 *
	 * @method ListProperties find_by_id($id, $sql_params = false)
	 * @method ListProperties find_by_form_identifier(string $identifier, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id(int|int[] $category_id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_active(int $active, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_id($id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_form_identifier(string|string[] $identifier, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] all($query_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active(int $selectedCategoryID, int $int, array $params)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active_and_title($categories, int $int, array $array, array $array1)
	 *
	 * @mixin \XELOS\Modules\Lists\Docs\ClassGenerated\Model\ListDocumentation
	 */
	class ListProperties extends \XELOS\Framework\Module\Model\DocumentModel implements \XELOS\Framework\Core\Interfaces\SearchableDocumentModelInterface
	{

		/**
			 * @var ListStatus[]|\XELOS\Framework\Module\Model\ModelCollection
			 */
		private $_ListStatusCollection;

		/** @var Category */
		private $category;

		/** @var \XELOS\Modules\Lists\Model\ListStatus */
		private $default_status;

		/**
			 * @var \XELOS\Modules\Lists\ListsController
			 */
		public $mod;

		 
		protected $model_default_render_xui;

		 
		public $model_version;

		 
		protected $properties;

		/** @var ListStatus[]|\XELOS\Framework\Module\Model\ModelCollection */
		private $statuses;

		 
		protected $table_auto_properties;

		 
		protected $table_name;

		 
		protected $table_use_group_id;



		/**
		 * Class XELOS\Modules\Lists\Model\ListProperties
		 *
		 * @property int    $id                       ID
		 * @property int    $user_id                  User ID
		 * @property int    $group_id                 Group ID
		 * @property int    $as_template              Is a template?
		 * @property int    $category_id              Category ID
		 * @property int    $active                   Active
		 * @property string $title                    Title
		 * @property string $list_type                standard, workflow, template
		 * @property string $form_identifier          Identifier
		 * @property string $form_type                Type [standalone|workflow]
		 * @property string $form_description         Description
		 * @property string $form_struct              Structure JSON encoded array of form fields
		 * @property int    $form_link                Form link for redirecting after form submits
		 * @property string $form_process             Processor [workflows]
		 * @property string $form_finish              Plain message after sending the form
		 * @property string $form_finish_html         HTML message after sending the form
		 * @property string $process_email_subject    Subject of form email
		 * @property string $process_email_recipients Recipients of form email
		 * @property string $process_db_storage_sql   Database storage SQL
		 * @property int    $process_workflow_id      Workflow ID
		 * @property int    $show_workflow_status     Shows the workflow status instead of the list status
		 * @property int    $item_count               Total items created for this list
		 * @property int    $created_at               Create date
		 * @property int    $updated_at               Last update date
		 * @property string $rights_check							enum: hidden|read_assigned|read_all|edit_assigned|edit_all
		 *
		 * @method ListProperties find_by_id($id, $sql_params = false)
		 * @method ListProperties find_by_form_identifier(string $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id(int|int[] $category_id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_active(int $active, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_id($id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_form_identifier(string|string[] $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] all($query_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active(int $selectedCategoryID, int $int, array $params)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active_and_title($categories, int $int, array $array, array $array1)
		 *
		 * @mixin \XELOS\Modules\Lists\Docs\ClassGenerated\Model\ListDocumentation
		 */
		public function __construct($id = false){}

		/**
		 * Class XELOS\Modules\Lists\Model\ListProperties
		 *
		 * @property int    $id                       ID
		 * @property int    $user_id                  User ID
		 * @property int    $group_id                 Group ID
		 * @property int    $as_template              Is a template?
		 * @property int    $category_id              Category ID
		 * @property int    $active                   Active
		 * @property string $title                    Title
		 * @property string $list_type                standard, workflow, template
		 * @property string $form_identifier          Identifier
		 * @property string $form_type                Type [standalone|workflow]
		 * @property string $form_description         Description
		 * @property string $form_struct              Structure JSON encoded array of form fields
		 * @property int    $form_link                Form link for redirecting after form submits
		 * @property string $form_process             Processor [workflows]
		 * @property string $form_finish              Plain message after sending the form
		 * @property string $form_finish_html         HTML message after sending the form
		 * @property string $process_email_subject    Subject of form email
		 * @property string $process_email_recipients Recipients of form email
		 * @property string $process_db_storage_sql   Database storage SQL
		 * @property int    $process_workflow_id      Workflow ID
		 * @property int    $show_workflow_status     Shows the workflow status instead of the list status
		 * @property int    $item_count               Total items created for this list
		 * @property int    $created_at               Create date
		 * @property int    $updated_at               Last update date
		 * @property string $rights_check							enum: hidden|read_assigned|read_all|edit_assigned|edit_all
		 *
		 * @method ListProperties find_by_id($id, $sql_params = false)
		 * @method ListProperties find_by_form_identifier(string $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id(int|int[] $category_id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_active(int $active, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_id($id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_form_identifier(string|string[] $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] all($query_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active(int $selectedCategoryID, int $int, array $params)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active_and_title($categories, int $int, array $array, array $array1)
		 *
		 * @mixin \XELOS\Modules\Lists\Docs\ClassGenerated\Model\ListDocumentation
		 */
		public function __toString(){}

		/**
			 * Can manage/moderate this list (can ALWAYS see ALL items)
			 * @return bool
			 */
		public function can_manage(){}

		/**
			 * Can read: User can read list
			 *
			 * @return bool
			 */
		public function can_read(){}

		/**
			 * Can write/edit items of this list
			 *
			 * @return bool
			 */
		public function can_write(){}

		/**
			 * Creates a copy of the list and related list statuses
			 *
			 * @param ListProperties $listProperties
			 * @param bool $with_items If true creates also a copy of all list items
			 *
			 * @return bool
			 * @throws \Exception
			 */
		public function copyToTarget($listProperties = NULL, $with_items = false){}

		/**
		 * Class XELOS\Modules\Lists\Model\ListProperties
		 *
		 * @property int    $id                       ID
		 * @property int    $user_id                  User ID
		 * @property int    $group_id                 Group ID
		 * @property int    $as_template              Is a template?
		 * @property int    $category_id              Category ID
		 * @property int    $active                   Active
		 * @property string $title                    Title
		 * @property string $list_type                standard, workflow, template
		 * @property string $form_identifier          Identifier
		 * @property string $form_type                Type [standalone|workflow]
		 * @property string $form_description         Description
		 * @property string $form_struct              Structure JSON encoded array of form fields
		 * @property int    $form_link                Form link for redirecting after form submits
		 * @property string $form_process             Processor [workflows]
		 * @property string $form_finish              Plain message after sending the form
		 * @property string $form_finish_html         HTML message after sending the form
		 * @property string $process_email_subject    Subject of form email
		 * @property string $process_email_recipients Recipients of form email
		 * @property string $process_db_storage_sql   Database storage SQL
		 * @property int    $process_workflow_id      Workflow ID
		 * @property int    $show_workflow_status     Shows the workflow status instead of the list status
		 * @property int    $item_count               Total items created for this list
		 * @property int    $created_at               Create date
		 * @property int    $updated_at               Last update date
		 * @property string $rights_check							enum: hidden|read_assigned|read_all|edit_assigned|edit_all
		 *
		 * @method ListProperties find_by_id($id, $sql_params = false)
		 * @method ListProperties find_by_form_identifier(string $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id(int|int[] $category_id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_active(int $active, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_id($id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_form_identifier(string|string[] $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] all($query_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active(int $selectedCategoryID, int $int, array $params)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active_and_title($categories, int $int, array $array, array $array1)
		 *
		 * @mixin \XELOS\Modules\Lists\Docs\ClassGenerated\Model\ListDocumentation
		 */
		public function delete(){}

		/**
			 * Get all accessible items for current user
			 *
			 * @param array  $filters = ['list_status'=>$statusId, 'workflow_status'=>$workflowStatusShortID, 'facetted_1'=>$facet1_filter]     The filters for the status_id and the facetted_1 - 5 fields
			 * @param string $order_field
			 * @param string $order_by
			 * @param int    $start   SQL Limit Start
			 * @param int    $limit   SQL Limit Count
			 * @param int   $count Total number of rows when no limit is present
			 *
			 * @return ListItem[]|\XELOS\Framework\Module\Model\ModelCollection
			 */
		public function getAccessibleItems($filters, $order_field = 'friendly_id', $order_by = 'ASC', $start = NULL, $limit = NULL, $count = NULL){}

		/**
			 * Return FDL for fields of specified type
			 *
			 * @param $fieldType
			 *
			 * @return array
			 */
		public function getFieldsByType($fieldType){}

		/**
			 * @return \XELOS\Framework\Module\Model\ModelCollection|ListStatus[]
			 */
		public function getListStatusCollection(){}

		/**
		 * Class XELOS\Modules\Lists\Model\ListProperties
		 *
		 * @property int    $id                       ID
		 * @property int    $user_id                  User ID
		 * @property int    $group_id                 Group ID
		 * @property int    $as_template              Is a template?
		 * @property int    $category_id              Category ID
		 * @property int    $active                   Active
		 * @property string $title                    Title
		 * @property string $list_type                standard, workflow, template
		 * @property string $form_identifier          Identifier
		 * @property string $form_type                Type [standalone|workflow]
		 * @property string $form_description         Description
		 * @property string $form_struct              Structure JSON encoded array of form fields
		 * @property int    $form_link                Form link for redirecting after form submits
		 * @property string $form_process             Processor [workflows]
		 * @property string $form_finish              Plain message after sending the form
		 * @property string $form_finish_html         HTML message after sending the form
		 * @property string $process_email_subject    Subject of form email
		 * @property string $process_email_recipients Recipients of form email
		 * @property string $process_db_storage_sql   Database storage SQL
		 * @property int    $process_workflow_id      Workflow ID
		 * @property int    $show_workflow_status     Shows the workflow status instead of the list status
		 * @property int    $item_count               Total items created for this list
		 * @property int    $created_at               Create date
		 * @property int    $updated_at               Last update date
		 * @property string $rights_check							enum: hidden|read_assigned|read_all|edit_assigned|edit_all
		 *
		 * @method ListProperties find_by_id($id, $sql_params = false)
		 * @method ListProperties find_by_form_identifier(string $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id(int|int[] $category_id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_active(int $active, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_id($id, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_form_identifier(string|string[] $identifier, $sql_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] all($query_params = false)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active(int $selectedCategoryID, int $int, array $params)
		 * @method \XELOS\Framework\Module\Model\ModelCollection|ListProperties[] find_all_by_category_id_and_active_and_title($categories, int $int, array $array, array $array1)
		 *
		 * @mixin \XELOS\Modules\Lists\Docs\ClassGenerated\Model\ListDocumentation
		 */
		public function getUniqueField(){}

		/**
			 * Access the list category.
			 *
			 * @return Category
			 */
		public function get_category(){}

		/**
			 * @return \XELOS\Modules\Lists\Model\ListStatus
			 */
		public function get_default_status(){}

		/**
			 * Returns the form field IDs for the facetted filter fields
			 * facetted_1 - facetted_5 in the list item, but not the list status,
			 * because it is saved in a separate row.
			 *
			 * @param bool $ignore_limit  Will return more than MAX_FILTERS
			 * @param bool $return_status Returns the status field, too, but doesn't count it against the limit
			 *
			 * @return array [$field_id => facetted_{1 - 5}
			 */
		public function get_facetted_fields($ignore_limit = false, $return_status = false){}

		/**
			 * Returns all distinct values of a facetted field.
			 *
			 * @param string $id Field ID, e.g AF-123ABC
			 *
			 * @return array
			 */
		public function get_facetted_values($id){}

		/**
			 * Return the current form in FDL array format
			 *
			 * @param string $show_only all|form|table|filter: Returns the FDL which has the show_in_xxx checkbox set
			 *
			 * @return array Form Description Array
			 */
		public function get_form_fdl($show_only = 'all'){}

		/**
			 * @return array
			 */
		public function get_status_pop_data(){}

		/**
			 * Has this list a field of a certain type?
			 *
			 * @param string $fieldType list_status,
			 *
			 * @return bool
			 */
		public function hasField($fieldType){}

		/**
			 * @inheritdoc
			 */
		public function onSearchIndexUpdate(\XELOS\Modules\Search\SearchIndexRecord $baseIndexRecord){}

		/**
			 * @return bool|int|null
			 * @throws \Exception
			 */
		public function save(){}

		/**
			 * @param \XELOS\Modules\Lists\Model\ListStatus $default_status
			 * @deprecated Workflow Workaround - remove
			 */
		public function set_default_status($default_status){}

		/**
			 * The status pop data can be set to prevent an additional call to the database to access the statuses multiple times.
			 * @deprecated Dirty Workflow Workaround - remove once tested
			 * @param array $statuses
			 */
		public function set_status_pop_data($statuses){}

		/**
			 * Tests if the form_identifier is unique and if only 5 facetted fields are selected.
			 *
			 * @param array $fieldErrors
			 *
			 * @return bool
			 */
		public function validate($fieldErrors){}

	}

	/**
	 * Class XELOS\Modules\Lists\Model\ListProperties
	 *
	 * @property int      $id
	 * @property int      $list_id
	 * @property string   $title       : stored in MySQL as varchar
	 * @property bool|int $default
	 * @property string   $rights_check: enum hidden|read_assigned|read_all|edit_assigned|edit_all
	 * @property int     $sort  : stored in MySQL as tinyint
	 * @property int      $created_at  : stored in MySQL as timestamp
	 * @property int      $updated_at  : stored in MySQL as timestamp
	 *
	 * @method ListStatus find_by_id($id, $sql_params = false)
	 * @method ListStatus find_by_list_id($id, $sql_params = false)
	 * @method ListStatus find_by_list_id_and_default($id, $default, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListStatus[] find_all_by_id($id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListStatus[] find_all_by_list_id($id, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListStatus[] find_all_by_list_id_and_default($id, $default, $sql_params = false)
	 * @method \XELOS\Framework\Module\Model\ModelCollection|ListStatus[] find_all_by_list_id_and_default_and_id($list_id, $default, $id, $sql_params = false)
	 */
	class ListStatus extends \XELOS\Framework\Module\Model\Model
	{

		/**
			 * @var \XELOS\Modules\Lists\ListsController
			 */
		public $mod;

		 
		public $model_version;

		 
		protected $table_auto_properties;

		 
		protected $table_name;

		 
		protected $table_use_group_id;



		/**
			 * Checks if a user can edit a list item with this status and the assigned users.
			 * The user can write if:
			 *  - he has the manage_list policy on the list
			 *  - he has the write_list policy and the status rights_check is edit_all or if it's edit_assigned and the user is assigned.
			 *
			 * @param string|array $assigned_user_ids Assigned users in list item
			 * @deprecated Should be list_item->can_write
			 *
			 * @return bool
			 */
		public function can_write($assigned_user_ids){}

		/**
			 * Returns the FDL for the table editor form.
			 *
			 * @return array
			 */
		public function get_fields(){}

		/**
			 * @param      $list_id
			 *
			 * @deprecated Should not be required, currently uses more DB calls than necessary. Remove once workflows are tested, try using ListProperties->get_status_pop_data
			 *
			 * @return array
			 */
		public function get_list_status_pop_data($list_id){}

		/**
			 * Returns the possible values for the list status policy
			 *
			 * @param bool $rendered
			 *
			 * @return array
			 */
		public function get_status_pop_data($rendered = true){}

		/**
			 * Makes sure that the currently saved status is the only with default=1.
			 *
			 * @return int
			 * @throws \Exception
			 */
		public function save(){}

	}
} 

namespace XELOS\Modules\Lists\Page{

	class EditItemPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		/**
			 * @param int $listID
			 * @param int $itemID
			 *
			 * @return bool|string|\xelos_global_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function page_overview($listID, $itemID){}

	}

	class ItemOverviewPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		/**
			 * Show all the accessible list entries of the selected list with the faceted search if it is activated.
			 *
			 * @param int $listID
			 *
			 * @return \xelos_template
			 */
		public function page_overview($listID){}

		/**
			 * Shows the readonly form for a list item if the user has the following policies:
			 *  - read category
			 *  - read list
			 *  - if the user only has read list: status rights_check is read_all or read_assigned and the user is assigned.
			 *
			 * @param int $list_id
			 * @param int $item_id
			 *
			 * @return \xelos_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function page_view($list_id, $item_id){}

	}

	class ListEditorPage extends \XELOS\Framework\Module\Page\Page
	{

		/**
			 * The different tabs / steps in the list editor
			 * @var array
			 */
		private $edit_steps;

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		/**
			 * Returns the form for the list title, form_identifier, description and category.
			 *
			 * @param \XELOS\Framework\XF\UI\Form $form
			 * @param int  $categoryID
			 *
			 * @return \XELOS\Framework\XF\UI\Form
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		private function get_form_edit_details($form, $categoryID){}

		/**
			 * Returns the form editor for the list.
			 *
			 * @param \XELOS\Framework\XF\UI\Form           $form
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 *
			 * @return \XELOS\Framework\XF\UI\Form
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		private function get_form_edit_form($form, $list){}

		/**
			 * Returns the processing tab for the list editor which includes the options to send emails and notifications and
			 * to start a workflow.
			 *
			 * @param \XELOS\Framework\XF\UI\Form           $form
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 *
			 * @return \XELOS\Framework\XF\UI\Form
			 */
		private function get_form_edit_processes($form, $list){}

		/**
			 * Returns the table editor to create and edit list statuses.
			 *
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 *
			 * @return \XELOS\Framework\XF\UI\TableEditor
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		private function get_form_edit_status($list){}

		/** @noinspection PhpInconsistentReturnPointsInspection
			 * @param bool $subpage
			 *
			 * @return \xelos_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function get_page($subpage = false){}

		public function init(){}

		/**
			 * Renders the list editor form for each tab and handles the saving of the list.
			 *
			 * @param string $step
			 * @param int    $form_id
			 * @param int    $categoryID
			 *
			 * @return \xelos_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		private function process_edit_step($step = '', $form_id, $categoryID){}

		/**
			 * Reset Steps
			 */
		private function resetSteps(){}

	}

	class OverviewPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		/**
			 * @throws \Exception
			 */
		private function handleActions(){}

		/**
			 * Show all accessible lists with their category.
			 *
			 * @return \XELOS\Framework\Core\Template
			 * @throws \Exception
			 */
		public function page_overview(){}

	}

	class SettingsPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		public function fillCategoryTreeCB(){}

		/**
			 * Show all forms per category
			 * @return \XELOS\Framework\Core\Template
			 */
		public function page_overview(){}

	}
} 

namespace XELOS\Modules\Lists\UI{

	class CategorySelector extends \XELOS\Framework\Module\UI\UIAjaxComponent
	{

		/** @var \XELOS\Framework\Module\Model\ModelCollection|\XELOS\Modules\Lists\Model\Category[] */
		private $categories;

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;

		/** @var bool */
		private $readOnly;

		/** @var string */
		private $renderMode;

		/** @var int */
		private $selectedCategoryID;

		/** @var \XELOS\Framework\XF\UI\Table */
		private $table;

		/** @var \XELOS\Framework\XF\UI\Tree */
		private $tree;



		public function init(){}

		public function process_xui(){}

		/**
			 * Actual rendering method - must be implemented by children.
			 * Returns a template or a string containing the HTML of the element's content.
			 *
			 * @return string|\XELOS\Framework\Core\Template
			 */
		protected function render_xui(){}

		/**
			 * @param \XELOS\Modules\Lists\Model\Category[]|\XELOS\Framework\Module\Model\ModelCollection $categories
			 * @param int          $selectedCategoryID
			 */
		public function setCategories($categories, $selectedCategoryID){}

		/**
			 * Set XUI to act as readonly, hiding all list actions and hide inactive lists
			 * @param bool $bool
			 */
		public function setIsReadOnly($bool = true){}

		public function setRenderMode($mode = 'self::RENDER_MODE_OVERVIEW'){}

	}

	class ItemEditor extends \XELOS\Framework\Module\UI\UIAjaxComponent
	{

		/** @var \XELOS\Framework\XF\UI\Form */
		private $form;

		/** @var \XELOS\Modules\Lists\Model\ListItem */
		private $item;

		/** @var \XELOS\Modules\Lists\Model\ListProperties */
		private $list;

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;

		/** @var bool */
		private $readOnly;



		/**
			 * @param $action
			 * @param $fdl
			 * @param $uploadDir
			 * @param $data
			 *
			 * @throws \Exception
			 */
		private function handleAction($action, $fdl, $uploadDir, $data){}

		public function init(){}

		/**
			 * @return bool|void
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 * @throws \Exception
			 */
		public function process_xui(){}

		/**
			 * Actual rendering method - must be implemented by children.
			 * Returns a template or a string containing the HTML of the element's content.
			 *
			 * @return string|\XELOS\Framework\Core\Template
			 */
		protected function render_xui(){}

		/**
			 * Set XUI to act as readonly, hiding all actions
			 *
			 * @param bool $bool
			 */
		public function setIsReadOnly($bool = true){}

		/**
			 * @param \XELOS\Modules\Lists\Model\ListItem $item
			 */
		public function setItem($item){}

		/**
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 */
		public function setList($list){}

	}

	class ItemList extends \XELOS\Framework\Module\UI\UIAjaxComponent
	{

		/** @var $filters = [['field'=>'value']] */
		private $filters;

		/** @var \XELOS\Modules\Lists\Model\ListProperties */
		private $list;

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;

		/**
			 * @var bool
			 */
		private $readOnly;

		/** @var \XELOS\Framework\XF\UI\Table */
		private $table;

		 
		public $workflowItems;

		/** @var \XELOS\Framework\Module\Model\ModelCollection */
		public $workflowPayloads;

		 
		public $workflowStates;

		/** @var \xm_workflows */
		public $workflowsMod;



		/**
			 * @param string $order_field
			 * @param string $order_by
			 * @param int    $start
			 * @param int    $limit
			 *
			 * @return array [
			 */
		private function _fillTableCB($order_field = NULL, $order_by = NULL, $start = NULL, $limit = NULL){}

		/**
			 * @throws \Exception
			 */
		public function process_xui(){}

		/**
			 * Actual rendering method - must be implemented by children.
			 * Returns a template or a string containing the HTML of the element's content.
			 *
			 * @return string|\XELOS\Framework\Core\Template
			 */
		protected function render_xui(){}

		/**
			 * Set Faceted Field Filters
			 *
			 * @param $filters = [['field'=>'value']]
			 */
		public function setFieldFilters($filters){}

		/**
			 * Set XUI to act as readonly, hiding all actions
			 *
			 * @param bool $bool
			 */
		public function setIsReadOnly($bool = true){}

		public function setList($list){}

		public function setTable($table){}

		public function setWorkflowItems($workflowItems){}

		public function setWorkflowPayloads($workflowPayloads){}

		public function setWorkflowStates($workflowStates){}

		public function setWorkflowsMod($mod){}

	}

	/**
	 * Class ThreadPreview
	 *
	 * @package XELOS\Modules\Lists\UI
	 */
	class ItemPreview extends \XELOS\Framework\Module\UI\Document
	{

		/** @var \XELOS\Modules\Lists\Model\ListItem */
		protected $model;



		/**
			 * @return string
			 * @throws \Exception
			 */
		public function get_description(){}

		/**
			 * Render a preview of the thread
			 * @throws \Exception
			 */
		public function get_full_preview(){}

		/**
			 * @inheritdoc
			 */
		public function get_image($w = false, $h = false, $cropmode = false){}

		/**
		 * Class ThreadPreview
		 *
		 * @package XELOS\Modules\Lists\UI
		 */
		public function get_title(){}

		/**
			 * Get Icon Class
			 * @return string
			 */
		public function get_title_icon_class(){}

		/**
		 * Class ThreadPreview
		 *
		 * @package XELOS\Modules\Lists\UI
		 */
		public function init(){}

	}

	class ListPortlet extends \XELOS\Framework\Module\UI\UIAjaxComponent
	{

		/**
			 * @var string
			 */
		private $listActionMode;

		/**
			 * The ID of the category which can be accessed at the highest level
			 * @var int
			 */
		private $maxParentCategory;

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;

		/**
			 * The ID of the parent category of the current one
			 * @var int
			 */
		private $parentCategory;

		/**
			 * Represents the title of the lists portlet
			 * @var string
			 */
		private $portletTitle;

		/**
			 * The rendered list which will be printed as HTML UL list
			 * @var array
			 */
		private $renderedList;

		/**
			 * The ID of the category which has been predefined or is currently selected
			 * @var int
			 */
		private $selectedCategory;



		public function process_xui(){}

		/**
			 * Actual rendering method - must be implemented by children.
			 * Returns a template or a string containing the HTML of the element's content.
			 *
			 * @return string|\XELOS\Framework\Core\Template
			 */
		protected function render_xui(){}

		public function setListActionMode($listActionMode){}

		/**
			 * @param int $maxParentCategory
			 */
		public function setMaxParentCategory($maxParentCategory){}

		/**
			 * @param string $portletTitle
			 */
		public function setPortletTitle($portletTitle){}

		/**
			 * @param int $selectedCategory
			 */
		public function setSelectedCategory($selectedCategory){}

	}

	/**
	 * Class ThreadPreview
	 *
	 * @package XELOS\Modules\Lists\UI
	 */
	class ListPreview extends \XELOS\Framework\Module\UI\Document
	{

		/** @var \XELOS\Modules\Lists\Model\ListProperties */
		protected $model;



		/**
			 * @return string
			 * @throws \Exception
			 */
		public function get_description(){}

		/**
			 * Render a preview of the thread
			 * @throws \Exception
			 */
		public function get_full_preview(){}

		/**
			 * @inheritdoc
			 */
		public function get_image($w = false, $h = false, $cropmode = false){}

		/**
		 * Class ThreadPreview
		 *
		 * @package XELOS\Modules\Lists\UI
		 */
		public function get_title(){}

		/**
			 * Get Icon Class
			 * @return string
			 */
		public function get_title_icon_class(){}

		/**
		 * Class ThreadPreview
		 *
		 * @package XELOS\Modules\Lists\UI
		 */
		public function init(){}

	}
} 

namespace XELOS\Modules\Lists\CF{

	class ListProperties extends \XELOS\Framework\Module\Hook\DocumentItem
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;

		 
		protected $model_name;



		/**
			 * @param string $name
			 *
			 * @return \XELOS\Framework\Module\Model\DocumentModel|\XELOS\Modules\Lists\Model\ListProperties
			 * @throws \Exception
			 */
		public function create_new($name){}

		/**
			 * Returns a view for editing the document before it is finally created.
			 * Often it is the edit view provided by DocumentItem::get_view()
			 *
			 * @param \XELOS\Framework\Module\Model\DocumentModel|\XELOS\Modules\Lists\Model\ListProperties $document
			 *
			 * @return mixed
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 * @throws \Exception
			 */
		public function get_draft_view(\XELOS\Framework\Module\Model\DocumentModel $document){}

		/**
			 * Returns the css icon class.
			 *
			 * @param mixed $document
			 * @return mixed
			 */
		public function get_icon_class($document = false){}

		/**
			 * Returns a specific view for the given document
			 *
			 * @param string                                      $view_name the unique name of the view for this cf document
			 * @param \XELOS\Framework\Module\Model\DocumentModel|\XELOS\Modules\Lists\Model\ListProperties $document  The document for which the views are to be created
			 * @param bool                                        $readonly  Indicates if the view is currently in readonly mode, even though the user might usually have write access
			 *
			 * @return \XELOS\Framework\Module\UI\UIAjaxComponent The view. It should be an instance of the UIAjaxComponent
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 */
		public function get_view($view_name, \XELOS\Framework\Module\Model\DocumentModel $document, $readonly = false){}

		/**
			 * Returns an array of name=>title pairs of all views that are available for the current document.
			 * Use realtime evaluation of the document only if necessary!
			 *
			 * @param \XELOS\Framework\Module\Model\DocumentModel $document The document for which the views are to be returned
			 *
			 * @return mixed[] An assoc array having the view names as its keys and the title of the view as the value
			 */
		public function get_views(\XELOS\Framework\Module\Model\DocumentModel $document){}

	}
} 

namespace XELOS\Modules\Lists\Hook\Portal{

	/**
	 * @desc PORTLET Lists Class
	 */
	class ListsPortletShowPortlet extends \XELOS\Framework\Module\Hook\ModulePortlet
	{

		 
		public $meta_info;

		/**
			 * @var \XELOS\Modules\Lists\ListsController
			 */
		public $mod;

		 
		public $portlet_config;

		 
		protected $portlet_title;



		/**
		 * @desc PORTLET Lists Class
		 */
		public function __construct(){}

		/**
			 * Get Config from this portlet
			 *
			 * @param mixed $component_id
			 *
			 * @return array|bool FDL or false on fail
			 */
		public function get_fdl($component_id = false){}

		/**
			 * @desc Return HTML
			 *
			 * @param string $size
			 *
			 * @return string
			 */
		public function get_html($size = 'default'){}

		/**
			 * @desc Return Title
			 */
		public function get_title(){}

		/**
		 * @desc PORTLET Lists Class
		 */
		public function init(){}

	}
} 

namespace XELOS\Modules\Lists\Hook\Webservice{

	class ApiService implements \XELOS\Modules\Webservice\Hook\ServiceInterface
	{

		/**
			 * @var \XELOS\Modules\Lists\ListsController
			 */
		public $mod;



		public function get_service_description(){}

		public function init(){}

		/**
			 * Get Accessible Items from a specific list
			 * @param     $listId
			 * @param int $start
			 * @param int $limit
			 *
			 * @return array
			 */
		public function list_items($listId, $start, $limit = 100){}

		/**
			 * Retrieve list of lists
			 *
			 * @param string $query
			 * @param int  $start
			 * @param int  $limit
			 *
			 * @return bool|mixed
			 */
		public function list_lists($query = NULL, $start, $limit = 100){}

	}
} 

namespace XELOS\Modules\Lists\Hook\Workflows{

	class EnsureFormPayloadAction extends \xelos_workflows_action_base
	{



		private function _get_forms(){}

		public function get_fdl(){}

		public function get_user_interface(){}

		public function has_ui_action(){}

	}

	/** @noinspection PhpIncludeInspection */
	class ListItemPayload extends \xelos_workflows_payload_base
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;

		/** @var string */
		protected $model_name;

		/** @var bool This payload is convertible to PDF */
		protected $payload_convertible_to_pdf;

		/** @var bool This payload is a reference */
		protected $payload_type_reference;



		/**
			 * Get FDL for states
			 *
			 * @return array FDL
			 */
		public function get_fdl(){}

		/**
			 * copied from xelos core, but prepended web_dir to path_to_file
			 *
			 * @param      $path_to_file
			 * @param bool $inline_disposition
			 * @param bool $name
			 * @param bool $zipOnTheFly
			 * @param bool $width
			 * @param bool $height
			 * @param bool $resize_mode
			 *
			 * @return string
			 */
		public function get_file_url($path_to_file, $inline_disposition = true, $name = false, $zipOnTheFly = false, $width = false, $height = false, $resize_mode = false){}

		/**
			 * @param $list_item
			 *
			 * @return \XELOS\Modules\Lists\Model\ListProperties
			 */
		private function get_list($list_item){}

		/**
			 * @param int $item_id
			 *
			 * @return \XELOS\Modules\Lists\Model\ListItem
			 */
		private function get_list_item($item_id){}

		/**
			 * Get payload properties
			 *
			 * @return mixed
			 */
		public function get_payload_properties(){}

		/**
			 * Get all placeholders with payload property values: It's required that the identifier of the form is the same as
			 * the payload identifier.
			 *
			 * @param bool $descriptive Show explanations and examples
			 *
			 * @return bool|array
			 * @throws \Exception
			 */
		public function get_placeholders($descriptive = false){}

		/**
			 * Prepare FDL fields
			 *
			 * @param array $fields
			 *
			 * @return array
			 */
		private function prepare_fdl($fields){}

		/**
			 * Set payload property
			 *
			 * @param string     $property
			 * @param string|int $value
			 *
			 * @return bool|int
			 * @throws \Exception
			 */
		public function set_payload_property($property, $value){}

		/**
			 * Show form
			 *
			 * @throws \Exception
			 * @throws ContentException
			 * @return \XELOS\Framework\Core\Template|void
			 */
		public function show_payload(){}

		/**
			 * return _files storage path for payload
			 * @return string $full_path
			 */
		public function storage_path(){}

		/**
			 * Get payload as HTML
			 *
			 * @param int   $list_item_id
			 * @param array $headerFields
			 *
			 * @return string
			 * @throws ContentException
			 */
		public function to_html($list_item_id, $headerFields = array ( )){}

	}

	/**
	 * Workflow action hook to change the value of a field in the list item payload.
	 *
	 */
	class SetFieldAction extends \xelos_workflows_action_base
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		/**
			 * Get form definition settings
			 *
			 * @return array
			 */
		public function get_fdl(){}

		/**
			 * Returns the form FDL of the selected field
			 *
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 * @param \XELOS\Modules\Lists\Model\ListItem       $list_item
			 * @param string         $field_shortname
			 * @param string         $field_value
			 *
			 * @return array
			 * @throws ActionException If the field is not available in the list fdl
			 */
		private function get_field_fdl(\XELOS\Modules\Lists\Model\ListProperties $list, \XELOS\Modules\Lists\Model\ListItem $list_item, $field_shortname, $field_value){}

		/**
			 * Returns the list to the list item.
			 *
			 * @param \XELOS\Modules\Lists\Model\ListItem $list_item
			 *
			 * @return \XELOS\Modules\Lists\Model\ListProperties
			 * @throws ActionException Should never happen: The list item has no list!
			 */
		private function get_list(\XELOS\Modules\Lists\Model\ListItem $list_item){}

		/**
			 * Returns the list item model from the payloads.
			 *
			 * @return \XELOS\Modules\Lists\Model\ListItem
			 * @throws ActionException If
			 */
		private function get_list_item(){}

		/**
			 * Overwrites the parent form because a lists module in a group context sets the wrong action URL,
			 * e.g. a list module installed in the groups instance projects would link to /projects_list/...
			 *
			 * @see xelos_workflows_action_base::get_ui_form()
			 *
			 * @param array|string $form_params FormName if string
			 *
			 * @return \XELOS\Framework\XF\UI\Form
			 */
		public function get_ui_form($form_params = array ( )){}

		/**
			 * Action UI-Interface
			 *
			 * @throws \Exception
			 * @throws ContentException
			 */
		public function get_user_interface(){}

		/**
		 * Workflow action hook to change the value of a field in the list item payload.
		 *
		 */
		public function has_ui_action(){}

		/**
			 * Set the item field to the selected value
			 *
			 * @throws \Exception $XF->lib->error->log Exception
			 * @return bool
			 */
		public function process(){}

		/**
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 * @param \XELOS\Modules\Lists\Model\ListItem       $list_item
			 * @param string         $field_shortname Shortname of the field, generated when the columns are saved.
			 * @param string         $field_value
			 *
			 * @throws ActionException If the field is not available in the list item or if the save fails
			 * @throws \Exception $XF->lib->error->log Exception
			 */
		private function set_field_value(\XELOS\Modules\Lists\Model\ListProperties $list, \XELOS\Modules\Lists\Model\ListItem $list_item, $field_shortname, $field_value){}

		/**
			 * Fetches the statuses with disabled group id and sets the status pop data and the default status in the list.
			 *
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 */
		private function set_list_statuses(\XELOS\Modules\Lists\Model\ListProperties $list){}

	}

	/** @noinspection PhpIncludeInspection */
	class ShowFormAction extends \xelos_workflows_action_base
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		/** @noinspection PhpIncludeInspection */
		public function get_fdl(){}

		/**
			 * Overwrites the parent form because a lists module in a group context sets the wrong action URL,
			 * e.g. a list module installed in the groups instance projects would link to /projects_list/...
			 *
			 * @see xelos_workflows_action_base::get_ui_form()
			 *
			 * @param array|string $form_params FormName if string
			 *
			 * @return \XELOS\Framework\XF\UI\Form
			 */
		public function get_ui_form($form_params = array ( )){}

		/**
			 * Action UI-Interface
			 *
			 * @throws \Exception
			 * @throws ContentException
			 */
		public function get_user_interface(){}

		/** @noinspection PhpIncludeInspection */
		public function has_ui_action(){}

		/**
			 * Fetches the statuses with disabled group id and sets the status pop data and the default status in the list.
			 *
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 */
		private function set_list_statuses(\XELOS\Modules\Lists\Model\ListProperties $list){}

	}

	/**
	 * Workflow action hook to change the value of a field in the list item payload.
	 *
	 */
	class UpdateStatusAction extends \xelos_workflows_action_base
	{



		/**
		 * Workflow action hook to change the value of a field in the list item payload.
		 *
		 */
		public function get_fdl(){}

		/**
			 * Returns the form FDL of the selected field
			 *
			 * @param ListProperties $list
			 * @param \XELOS\Modules\Lists\Model\ListItem       $list_item
			 * @param string         $field_shortname
			 * @param string         $field_value
			 *
			 * @return array
			 * @throws ActionException If the field is not available in the list fdl
			 */
		private function get_field_fdl(\XELOS\Modules\Lists\Model\ListProperties $list, \XELOS\Modules\Lists\Model\ListItem $list_item, $field_shortname, $field_value){}

		/**
			 * Returns the list to the list item.
			 *
			 * @param \XELOS\Modules\Lists\Model\ListItem $list_item
			 *
			 * @return ListProperties
			 * @throws ActionException Should never happen: The list item has no list!
			 */
		private function get_list(\XELOS\Modules\Lists\Model\ListItem $list_item){}

		/**
			 * Returns the list item model from the payloads.
			 *
			 * @return \XELOS\Modules\Lists\Model\ListItem
			 * @throws ActionException If
			 */
		private function get_list_item(){}

		/**
			 * Set the item field to the selected value
			 *
			 * @throws \Exception $XF->lib->error->log Exception
			 * @return bool
			 */
		public function process(){}

		/**
			 * Fetches the statuses with disabled group id and sets the status pop data and the default status in the list.
			 *
			 * @param ListProperties $list
			 */
		private function set_list_statuses(\XELOS\Modules\Lists\Model\ListProperties $list){}

	}

	trait WorkflowItemTrait
	{

		/** @var \XELOS\Modules\Lists\ListsController */
		public $mod;



		/**
			 * Returns the form FDL of the selected field
			 *
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 * @param \XELOS\Modules\Lists\Model\ListItem       $list_item
			 * @param string         $field_shortname
			 * @param string         $field_value
			 *
			 * @return array
			 * @throws ActionException If the field is not available in the list fdl
			 */
		private function get_field_fdl(\XELOS\Modules\Lists\Model\ListProperties $list, \XELOS\Modules\Lists\Model\ListItem $list_item, $field_shortname, $field_value){}

		/**
			 * Returns the list to the list item.
			 *
			 * @param \XELOS\Modules\Lists\Model\ListItem $list_item
			 *
			 * @return \XELOS\Modules\Lists\Model\ListProperties
			 * @throws ActionException Should never happen: The list item has no list!
			 */
		private function get_list(\XELOS\Modules\Lists\Model\ListItem $list_item){}

		/**
			 * Returns the list item model from the payloads.
			 *
			 * @return \XELOS\Modules\Lists\Model\ListItem
			 * @throws ActionException If
			 */
		private function get_list_item(){}

		/**
			 * Fetches the statuses with disabled group id and sets the status pop data and the default status in the list.
			 *
			 * @param \XELOS\Modules\Lists\Model\ListProperties $list
			 */
		private function set_list_statuses(\XELOS\Modules\Lists\Model\ListProperties $list){}

	}
} 

