<?php
namespace {
}



namespace XELOS\Modules\Webservice{

	/**
	 * Class xm_webservice
	 *
	 * @package XELOS\Modules\Webservice
	 * @property-read xm_webservice_magic_action $action
	 * @property-read xm_webservice_magic_model  $model
	 */
	class WebserviceController extends \XELOS\Framework\Module\Controller implements \XELOS\Framework\Core\Interfaces\ModuleInterface
	{

		 
		private $delimiter;

		/**
			 * OAuth Info
			 *
			 * @var \XELOS\Modules\Webservice\Model\OauthAccess
			 */
		private $oauth_info;

		/**
			 * @desc Service Endpoint (Location)
			 */
		private $service_endpoint;

		/**
			 * @desc Service Namespace (xelos.net)
			 */
		private $service_ns;

		/**
			 * @var \XELOS\Modules\Webservice\Lib\SoapServer
			 */
		private $soap_server;



		/**
		 * Class xm_webservice
		 *
		 * @package XELOS\Modules\Webservice
		 * @property-read xm_webservice_magic_action $action
		 * @property-read xm_webservice_magic_model  $model
		 */
		public function __construct($instance){}

		/**
			 * @desc Converts an "Easy Function" Array to Service Description Array
			 *
			 * @param array Type Description
			 *
			 * @returns array HighLevel Types
			 * @return array
			 */
		private function create_param_array($param_description){}

		/**
			 * Returns a  table which contains all connected oauth clients.
			 *
			 * @param int $userId
			 *
			 * @return \XELOS\Framework\XF\UI\Table
			 * @throws \Exception
			 */
		public function getConnectedClientsTable($userId){}

		/**
			 * @param int  $userId
			 *
			 * @param bool $showUserAccounts
			 *
			 * @return array
			 * @throws \Exception
			 */
		public function getDisconnectedClientLinks($userId, $showUserAccounts = true){}

		/**
			 * Returns Func Delimiter used to separate instance/function/portname
			 * @return string
			 */
		public function get_delimiter(){}

		/**
			 * Get OAuth Info
			 * @return \XELOS\Modules\Webservice\Model\OauthAccess or False
			 */
		public function get_oauth_info(){}

		/**
			 * @desc Main Functions: Show WSDL or Service Call
			 *
			 * @param string $page_id
			 * @param array  $args
			 *
			 * @return string|\XELOS\Framework\Core\Template
			 */
		public function get_page($page_id, $args = array ( )){}

		/**
		     * @desc Return Soap Client
		     *
		     * @param string URL to Service
		     * @param bool URL to WSDL or true if same as Service URL
		     * @param string UserName
		     * @param string Password
		     *
		     * @return \nusoap_client
				 * @deprecated The SOAP client does not work with proxy servers. Use xm_system_updater::get_package_manager_service() instead.
		     */
		public function get_soap_client($server = '', $wsdl = true, $user = '', $password = ''){}

		/**
			 * @desc Get XSD data-type
			 *
			 * @param string PHP/XF Data-Type Definition
			 *
			 * @returns string XSD (XML Schema Definition)
			 * @return string
			 */
		private function get_xsd_type($var){}

		/**
			 * @desc Initialize Soap Service Object
			 */
		public function init_server(){}

		/**
			 * @desc Is Array Associative (CHECK FOR COMPAT BEFORE 5.1)
			 *
			 * @param array $array
			 *
			 * @return bool
			 */
		private function is_assoc_array($array){}

		/**
			 * @desc Pass a Service Request to specific Module and return
			 *
			 * @returns string XML/Soap Object
			 * @throws \Exception
			 */
		public function page_invoke_service(){}

		/**
			 * @desc Compile a WSDL file from all valid Services in the system
			 *
			 * @param array modules to show wsdl from [default: all]
			 *
			 * @returns string WSDL / XML
			 * @return string
			 * @throws \Exception
			 */
		public function page_wsdl(){}

		/**
			 * @desc Register all available methods from a specific port (= hook)
			 *
			 * @param string Portname (Instance.Hook)
			 * @param string PortDescription (e.g. CRM Contactlog API)
			 * @param array Methods - which function can be invoked on the hook-object and what is the expected i/o
			 */
		public function register_service_hook($portname, $portdescription, $methods){}

		/**
			 * Register all available modules to be displayed and processed
			 * @throws \Exception
			 */
		public function register_service_hooks(){}

		/**
			 * Set OAuth Info for current Session
			 *
			 * @param \XELOS\Modules\Webservice\Model\OauthAccess $oauth
			 */
		public function set_oauth_info(\XELOS\Modules\Webservice\Model\OauthAccess $oauth){}

	}
} 

namespace XELOS\Modules\Webservice\Action{

	/**
	 * Class xaction_webservice_oauth_client
	 *
	 * @package XELOS\Modules\Webservice\Action
	 */
	class OAuthClientAction
	{

		/** @var \XELOS\Modules\Webservice\WebserviceController */
		public $mod;



		/**
			 * Process Authorization flows for oauth_clients
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 * @throws \Exception
			 */
		public function authorize(){}

		/**
			 * Parsing the state which keeps on end the
			 * modulename and hookname necessary to identifier
			 *
			 * @param string $state Base64 encoded state
			 *
			 * @return array [
			 *                  'user_id'=>1,
			 *                  'context'=>$instance,
			 *                  'hook'=>$hook,
			 *                  'secure_token'=>$token,
			 *                  'time'=>$time,
			 *                  'redirect_url'=>$redirectURI
			 *              ]
			 */
		public function decodeState($state){}

		/**
			 * @param $oauth_access_id
			 *
			 * @param $redirect_url
			 *
			 * @throws \Exception
			 */
		public function deleteConnection($oauth_access_id, $redirect_url){}

		/**
			 * @param      $context
			 * @param      $hook_name
			 * @param null $redirect_url
			 *
			 * @return string Base64 encoded state param
			 */
		public function encodeState($context, $hook_name, $redirect_url = NULL){}

		/**
			 * @param $oauth_access_id
			 *
			 * @param $redirect_url
			 *
			 * @throws \Exception
			 */
		public function reconnect($oauth_access_id, $redirect_url){}

		/**
			 * @param $oauth_access_id
			 */
		public function testConnection($oauth_access_id){}

	}

	/**
	 * Class OAuthServerAction
	 *
	 * @package XELOS\Modules\Webservice\Action
	 */
	class OAuthServerAction
	{

		/** @var array */
		private $authorized_clients;

		/** @var bool */
		private $authorized_clients_restricted;

		/** @var \XELOS\Modules\Webservice\WebserviceController */
		public $mod;

		/** @var string */
		protected $scopeSeparator;

		/** @var array */
		protected $validScopes;



		/**
			 * Return Auth Error Response
			 *
			 * @param string $error_type
			 * @param string $error_description
			 *
			 * @return string
			 */
		public function auth_error_response($error_type = 'invalid_client', $error_description = NULL){}

		/**
			 * Authorize Clients
			 * @Example: http://tutorials.jenkov.com/oauth2/authorization-code-request-response.html
			 *
			 * @return string
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 * @throws \Exception
			 */
		public function authorize(){}

		/**
			 * API Access
			 *
			 * @param mixed $access_token
			 *
			 * @return bool
			 */
		public function authorize_api_access($access_token){}

		/**
			 * Check OAuth Authorization Code
			 *
			 * @param mixed $code
			 *
			 * @return \XELOS\Modules\Webservice\Model\OauthAccess|false
			 */
		public function check_authorization_code($code){}

		/**
			 * Check OAuth Authorization Code
			 *
			 * @param mixed $refreshToken
			 *
			 * @return \XELOS\Modules\Webservice\Model\OauthAccess|bool
			 */
		public function check_refresh_token($refreshToken){}

		/**
			 * @return string
			 */
		public function getScopeSeparator(){}

		/**
			 * Check OAuth Authorization Code
			 *
			 * @param string $scope
			 * @param bool $user_id
			 *
			 * @return string
			 * @throws \Exception
			 */
		public function get_authorization_code($scope, $user_id = false){}

		/**
			 * Return Authorization URL
			 *
			 * @param mixed $client_id
			 * @param mixed $user_id
			 * @param string $scope
			 *
			 * @return string
			 * @throws \Exception
			 */
		public function get_authorization_url($client_id, $user_id, $scope){}

		/**
			 * @param string $bearerToken
			 * @param string $instance
			 *
			 * @return bool
			 */
		public function hasScopeAccess($bearerToken, $instance){}

		/**
		 * Class OAuthServerAction
		 *
		 * @package XELOS\Modules\Webservice\Action
		 */
		public function init(){}

		/**
			 * Returns true if the passed authorization code is still valid
			 *
			 * @param string $auth_code
			 * @param bool   $user_id
			 *
			 * @return string
			 */
		public function is_authorization_code_valid($auth_code, $user_id = false){}

	}
} 

namespace XELOS\Modules\Webservice\Hook{

	/**
	 * Class OAuthClient
	 *
	 *
	 * @package XELOS\Modules\Webservice\Hook
	 */
	abstract class OAuthClientHook extends \XELOS\Framework\Module\Hook\BaseHook
	{

		/**
			 * Description for the OAuth Client Hook
			 * will be used in create modal client
			 * @var
			 */
		protected $description;

		/**
			 * Client Icon for the OAuth Client Hook
			 * @var
			 */
		protected $icon_class;

		/**
			 * How many client connections are allowed on global level
			 * @var int 0 = No global service, 1 = single connection, -1 = no limit
			 */
		protected $max_global_connections;

		/**
			 * How many client connections are allowed per user
			 * @var int 0 = No user service, 1 = single connection, -1 = no limit
			 */
		protected $max_user_connections;

		/**
			 * Title for this OAuth Client Hook
			 * will be used in create modal client
			 * @var
			 */
		protected $title;

		/**
			 * @var \XELOS\Modules\Webservice\WebserviceController mod
			 */
		private $webserviceMod;



		/**
			 * You can check/process the client connection before the client is saved as oauth_access in webservices, this point
			 * can also be used to do custom redirects
			 *
			 * @param \XELOS\Modules\Webservice\Lib\OAuthClient $client
			 *
			 * @return bool True - client is good and should be saved, False - client connection is not good
			 */
		public function checkClientAfterAuthorization(\XELOS\Modules\Webservice\Lib\OAuthClient $client){}

		/**
			 * Return OAuth Client
			 *
			 * @param string $client_id
			 * @param string $client_secret
			 * @param null   $redirectURL Redirect triggered AFTER successfule authflow
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OAuthClient
			 */
		public function createOAuthClient($client_id, $client_secret = '', $redirectURL = NULL){}

		/**
			 * Get a state value for OAuth flow
			 *
			 * @param null $redirect_url
			 *
			 * @return bool|string
			 */
		public function createState($redirect_url = NULL){}

		/**
			 * Get connected client which belongs to specific oauth hook
			 *
			 * @param string $type
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OAuthClient
			 *
			 * @throws \InvalidArgumentException
			 * @throws \League\OAuth2\Client\Provider\Exception\IdentityProviderException
			 */
		public function getConnectedClient($type = 'personal'){}

		/**
			 * Get description for the OAuth Client Hook
			 * will be used in create modal client
			 *
			 * @return string
			 */
		public function getDescription(){}

		/**
			 * Get icon for the OAuth Client Hook
			 * will be used in create modal client
			 *
			 * @return string
			 */
		public function getIconClass(){}

		/**
			 * @param array       $connection_fdl_result
			 * @param string|null $internal_redirect_url
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OAuthClient
			 */
		abstract public function getOAuthClient($connection_fdl_result = NULL, $internal_redirect_url = NULL);

		/**
			 * Get title for the OAuth Client Hook
			 * will be used in create modal client
			 *
			 * @return string
			 */
		public function getTitle(){}

		/**
			 * TODO: What if the service requires the user to enter something during the connection?
			 */
		public function get_connection_fdl(){}

		/**
			 * Webservice Mod will be initialized
			 */
		public function init(){}

		/**
			 * Called from init, use to setup your configuration settings within the hook (optional)
			 */
		public function init_service(){}

		/**
			 * Returns whether the client allows an explicit connection
			 * triggered by the user e.g. via button.
			 *
			 * @return bool
			 */
		public function isAllowedExplicitConnection(){}

		/**
			 * @return bool
			 */
		public function isAllowedMultipleForUsers(){}

		/**
			 * @return bool
			 */
		public function isAllowedMultipleGlobal(){}

		/**
			 * Returns if this API should be connectable by users in their settings
			 * Default will evaluate max_user_connections
			 * Override this method to implement your own logic (e.g. policy based)
			 * @return bool
			 */
		public function isHiddenForUsers(){}

		/**
			 * Returns if this API should be connectable by by administrators in global mode
			 * Default will evaluate max_global_connections
			 * Override this method to implement your own logic (e.g. policy based)
			 * @return bool
			 */
		public function isHiddenGlobal(){}

		/**
			 * @return bool
			 */
		public function isSingleForUsers(){}

		/**
			 * @return bool
			 */
		public function isSingleGlobal(){}

		/**
			 * @param OAuthClientHook $oauthClientHook
			 */
		public function onBeforeSaveClient(\XELOS\Modules\Webservice\Hook\OAuthClientHook $oauthClientHook){}

		/**
			 * Parse OpenID OpenIDConfiguration for OAuth Service Endpoints
			 *
			 * @param string $url https://www.example.com/.well-known/openid-configuration
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OpenIDConfiguration|false
			 */
		protected function parseOpenIDConfiguration($url){}

		/**
			 * Parse OpenID OpenIDConfiguration for OAuth Service Endpoints
			 *
			 * @param string $domain www.example.com
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OpenIDConfiguration|false
			 */
		protected function parseOpenIDConfigurationForDomain($domain){}

		/**
			 * Save and encrypt oauth data to database
			 *
			 * @param \XELOS\Modules\Webservice\Lib\OAuthClient $client
			 * @param             $hook_name
			 * @param             $hook_instance
			 *
			 * @return int|bool
			 * @throws \League\OAuth2\Client\Provider\Exception\IdentityProviderException
			 * @throws \Exception
			 */
		public function saveOAuthAccess(\XELOS\Modules\Webservice\Lib\OAuthClient $client, $hook_name, $hook_instance){}

	}

	interface ServiceInterface
	{



		/**
			 * @desc Returns SOAP Service Description
			 * @returns array SOAP Description Array
			 */
		public function get_service_description();

		/**
			 * Initialization after construction with access to $this->mod
			 */
		public function init();

	}

	class SoapService implements \XELOS\Modules\Webservice\Hook\ServiceInterface
	{

		/**
			 * @var \XELOS\Modules\Webservice\WebserviceController
			 */
		public $mod;



		public function get_service_description(){}

		public function init(){}

		/**
			 * Retrieve list of active instances
			 *
			 * @param string $module Optional param to limit the return to a specific type of module
			 *
			 * @return bool|mixed
			 */
		public function list_instances($module = NULL){}

	}
} 

namespace XELOS\Modules\Webservice\Lib{

	/**
	 * Class OAuthClient
	 * @package XELOS\Modules\Webservice\Hook
	 */
	class OAuthClient
	{

		/**
			 * Access token Object representing string like
			 * accessToken an authorization issued to the client
			 * refreshToken see refreshToken
			 *
			 * @var \League\OAuth2\Client\Token\AccessToken
			 */
		protected $accessToken;

		/**
			 * To obtain an Access Token, an ID Token, and optionally a Refresh Token,
			 * the RP (Client) sends a Token Request to the Token Endpoint to obtain a Token Response
			 * @var string
			 */
		protected $accessTokenUrl;

		/**
			 * The Authorization Endpoint performs Authentication of the End-User.
			 * This is done by sending the User Agent to the Authorization Server's Authorization Endpoin
			 * @var string
			 */
		protected $authorizeUrl;

		/**
			 * The application's Client ID.
			 * Find this value at the Application's Settings.
			 *
			 * @var string
			 */
		protected $clientId;

		/**
			 * The application's Client Secret.
			 * @var string
			 */
		protected $clientSecret;

		/**
			 * The authorization code received from the authorization server
			 *
			 * @var string
			 */
		protected $code;

		/**
			 * Code Challenge created from codeVerifier
			 * @var string
			 */
		private $codeChallenge;

		/**
			 * The hashing method for the PKCE exchange, usually is S256 for SHA256
			 * @var string
			 */
		private $codeChallengeMethod;

		/**
			 * Code Verifier to be used in PKCE
			 * @var string
			 */
		private $codeVerifier;

		/**
			 * A URL where you can end a session by revoking an access_token.
			 * The token must be provided in the Authorization header or a session cookie must be used.
			 * @var string
			 */
		protected $endSessionUrl;

		/**
			 * The lifetime in seconds of the access token
			 *
			 * @var int
			 */
		protected $expires;

		/**
			 * false = Admin has created account
			 * @var bool
			 */
		protected $isPersonal;

		/**
			 * Additional optional query parameters used to start the auth process.
			 *
			 * @var array
			 */
		private $optionalAuthParams;

		/**
			 * Represents a generic service provider that may be used to interact with any
			 * OAuth 2.0 service provider, using Bearer token authentication.
			 *
			 * @var OAuthProvider
			 */
		private $provider;

		/**
			 * The URL to which Auth will redirect the browser after authorization has been granted by the user.
			 * The Authorization Code will be available in the code URL parameter.
			 * This URL must be specified as a valid callback URL under your Application's Settings.
			 *
			 * @var string
			 */
		protected $redirectUrl;

		/**
			 * Refresh tokens are issued to the client by the authorization server and are
			 * used to obtain a new access token when the current access token becomes invalid or expires
			 *
			 * @var string
			 */
		protected $refreshToken;

		/**
			 * Resource Param to be used when requesting API access code (e.g. for MS Graph API)
			 * @var string
			 */
		private $resource;

		/**
			 * @var
			 */
		protected $resourceOwner;

		/**
			 * The scopes which you want to request authorization for.
			 * These must be separated by a space.
			 * @var string
			 */
		protected $scope;

		/**
			 * During the Code Exchange for Access Token Flow it might be required to send clientId and clientSecret as Basic Authorization Header
			 * @var bool
			 */
		private $sendBasicAuthorization;

		/**
			 * An opaque value the application adds to the initial request that
			 * Auth includes when redirecting back to the application.
			 * This value must be used by the application to prevent CSRF attacks.
			 * @var string
			 */
		protected $state;



		/**
			 * OAuthClient constructor.
			 *
			 * @param string $clientId     The application's Client ID.
			 * @param string $clientSecret The application's Client Secret.
			 * @param string $redirectUrl  The URL to which Auth will redirect the browser after authorization has been granted
			 *                             by the user. Will default to webservice OAuth Endpoint
			 */
		public function __construct($clientId = NULL, $clientSecret = NULL, $redirectUrl = NULL){}

		/**
			 * Adds a new scope to the existing scopes.
			 *
			 * @param $scope
			 *
			 * @return OAuthClient
			 */
		public function addScope($scope){}

		/**
			 * Logout
			 *
			 * @param string $redirect_url
			 *
			 * @throws \Exception
			 */
		public function disconnect($redirect_url){}

		/**
			 * @param array $data
			 *
			 * @return OAuthClient
			 */
		public function fromArray(array $data){}

		/**
			 * Function to test connection directly to an oauth server
			 *
			 * @internal
			 * @return \League\OAuth2\Client\Token\AccessToken
			 */
		protected function getAccessToken(){}

		/**
			 * @return string
			 * @throws IdentityProviderException
			 */
		public function getAccessTokenAsString(){}

		/**
			 * @return mixed
			 */
		public function getAccessTokenUrl(){}

		/**
			 * @return mixed
			 */
		public function getAuthorizeUrl(){}

		/**
			 * Get application's Client ID.
			 *
			 * @return string
			 */
		public function getClientId(){}

		/**
			 * Get application's Client Secret
			 * @return string
			 */
		public function getClientSecret(){}

		/**
			 * @return string
			 */
		public function getCode(){}

		/**
			 * @return string
			 */
		public function getEndSessionUrl(){}

		/**
			 * @return int
			 */
		public function getExpires(){}

		/**
			 * @param string $redirect_url
			 *
			 * @return string
			 */
		public function getPostLogoutRedirectUrl($redirect_url){}

		/**
			 * Get GenericProvider lazyloaded once needed
			 * @return OAuthProvider
			 */
		private function getProvider(){}

		/**
			 * @return mixed
			 */
		public function getRedirectUrl(){}

		/**
			 * @return string
			 */
		public function getRefreshToken(){}

		/**
			 * @return string
			 */
		public function getScope(){}

		/**
			 * Returns the scope as array.
			 *
			 * @return array
			 */
		public function getScopeArray(){}

		/**
			 * @return string
			 */
		public function getState(){}

		/**
			 * @return int
			 */
		public function hasExpired(){}

		/**
			 * Prove connection within xelos intranet to avoid
			 * to much request to an oauth server
			 *
			 * @return bool
			 * @throws IdentityProviderException
			 */
		public function isConnected(){}

		/**
			 * @return bool
			 */
		public function isPersonal(){}

		/**
			 * @return bool
			 */
		public function isSendBasicAuthorization(){}

		/**
			 * Process Authorization Code Grant
			 * @param  string     $code Authorization Code
			 *
			 * @return bool
			 */
		public function processAuthorizationCodeResponse($code){}

		/**
			 * Use an OpenID Configuration to setup this OAuth client
			 *
			 * @param OpenIDConfiguration $config
			 */
		public function processOpenIDConfiguration(\XELOS\Modules\Webservice\Lib\OpenIDConfiguration $config){}

		/**
			 * Returns the access token or null if there is no token yet.
			 * If there is a token and the token is expired, it will
			 * automatically request a new access token by using the refresh token.
			 *
			 * @return \League\OAuth2\Client\Token\AccessToken
			 *
			 * @throws IdentityProviderException //League does not reveal Exceptions in their comments
			 */
		public function refreshAccessToken(){}

		/**
			 * @param \League\OAuth2\Client\Token\AccessToken $token
			 *
			 * @return $this
			 */
		public function setAccessToken(\League\OAuth2\Client\Token\AccessToken $token = NULL){}

		/**
			 * @param mixed $accessTokenUrl
			 *
			 * @return OAuthClient
			 */
		public function setAccessTokenUrl($accessTokenUrl){}

		/**
			 * @param mixed $authorizeUrl
			 *
			 * @return OAuthClient
			 */
		public function setAuthorizeUrl($authorizeUrl){}

		/**
			 * Set application's Client ID.
			 * Find this value at your Application's Settings.
			 *
			 * @param string $clientId
			 *
			 * @return OAuthClient
			 */
		public function setClientId($clientId){}

		/**
			 * Set application's Client Secret
			 *
			 * @param mixed $clientSecret
			 *
			 * @return OAuthClient
			 */
		public function setClientSecret($clientSecret){}

		/**
			 * @param $endSessionEndpoint
			 *
			 * @return $this
			 */
		public function setEndSessionUrl($endSessionEndpoint){}

		/**
			 * @param array $params
			 *
			 * @return OAuthClient
			 */
		public function setOptionalAuthParams(array $params){}

		/**
			 * Set Code Verifier and Code Challenge Method for RFC 7636: Proof Key for Code Exchange (PKCE) which is an alternative to client_secret or may be used in hybrid flows
			 *
			 * @param string $codeVerifier Empty will disable PKCE for the process/client
			 * @param string $codeChallengeMethod
			 */
		public function setPKCEParams($codeVerifier, $codeChallengeMethod = 'S256'){}

		/**
			 * @param mixed $redirectUrl
			 *
			 * @return OAuthClient
			 */
		public function setRedirectUrl($redirectUrl){}

		/**
			 * @param string $token
			 *
			 * @return OAuthClient
			 */
		public function setRefreshToken($token){}

		/**
			 * Set additional resource param when requesting access code
			 *
			 * @param $resource
			 */
		public function setResource($resource = NULL){}

		/**
			 * Set scopes which you want to request authorization for.
			 * These must be separated by a space.
			 *
			 * @param string $scope
			 *
			 * @return OAuthClient
			 */
		public function setScope($scope){}

		/**
			 * Should client_id and client_secret be sent as Basic Auth Header during code exchange?
			 * @param bool $sendBasicAuthorization
			 */
		public function setSendBasicAuthorization($sendBasicAuthorization = true){}

		/**
			 * @param string $state
			 *
			 * @return OAuthClient
			 */
		public function setState($state){}

		/**
			 * Start Authorization Code Grant flow (redirect to authorizeUrl)
			 * @throws \Exception
			 */
		public function startAuthorisationCodeFlow(){}

		/**
			 * @return array
			 */
		public function toArray(){}

	}

	/**
	 * Class OAuthProvider
	 * @package XELOS\Modules\Webservice\Lib
	 */
	class OAuthProvider extends \League\OAuth2\Client\Provider\GenericProvider
	{



		/**
			 * Returns authorization parameters based on provided options.
			 *
			 * @param  array $options
			 * @return array Authorization parameters
			 */
		protected function getAuthorizationParameters(array $options){}

	}

	/**
	 * Class OpenIDConfiguration
	 *
	 * @package XELOS\Modules\Webservice\Lib
	 */
	class OpenIDConfiguration
	{

		 
		protected $authorizationEndpoint;

		 
		protected $endSessionEndpoint;

		 
		protected $issuerUri;

		 
		protected $jwksUri;

		 
		protected $tokenEndpoint;



		/**
			 * OpenIDConfiguration constructor.
			 *
			 * @param string $url https://www.example.com/.well-known/openid-configuration
			 *
			 * @throws \InvalidArgumentException
			 */
		public function __construct($url){}

		/**
			 * Get Authorization Endpoint
			 *
			 * @return string
			 */
		public function getAuthorizationEndpoint(){}

		/**
			 * Get Logout Endpoint
			 *
			 * @return string
			 */
		public function getEndSessionEndpoint(){}

		/**
			 * Get IssuerUri
			 *
			 * @return string
			 */
		public function getIssuerUri(){}

		/**
			 * Get JSON Web Key Set Uri
			 *
			 * @return string
			 */
		public function getJwksUri(){}

		/**
			 * Get AccessToken Endpoint
			 *
			 * @return string
			 */
		public function getTokenEndpoint(){}

		/**
			 * Parse OpenID OpenIDConfiguration for OAuth Service Endpoints
			 *
			 * @param string $url https://www.example.com/.well-known/openid-configuration
			 *
			 * @throws \InvalidArgumentException
			 */
		private function parseOpenIDConfiguration($url){}

	}

	/**
	 * @desc Redeclaration of the nuSOAP Server Class
	 */
	class SoapServer extends \nusoap_server
	{

		/**
			 * @var \XELOS\Modules\Webservice\WebserviceController
			 */
		private $XF_mod;



		/**
			 * invokes a PHP function for the requested SOAP method
			 *
			 * The following fields are set by this function (when successful)
			 *
			 * methodreturn
			 *
			 * Note that the PHP function that is called may also set the following
			 * fields to affect the response sent to the client
			 *
			 * responseHeaders
			 * outgoing_headers
			 *
			 * This sets the fault field on error
			 *
			 * @access   private
			 * @throws \Exception
			 */
		public function invoke_method(){}

		/**
			 * @desc Set XF Mod-Handler
			 *
			 * @param $ref
			 */
		public function set_xf_module($ref){}

	}
} 

namespace XELOS\Modules\Webservice\Model{

	/**
	 * Class xmodel_webservice_oauth_access
	 *
	 * @package XELOS\Modules\Webservice\Model
	 *
	 * @property string     access_token
	 * @property int        expires_at
	 * @property string     authorization_code
	 * @property string     scope
	 * @property int|string user_id if is -1 is general account
	 * @property string     hook_name
	 * @property string     hook_instance
	 * @property string     oauth_data
	 * @property string     refresh_token
	 * @property int        system_user_device_id
	 * @property int      updated_at
	 *
	 * @method OauthAccess find_by_id($id)
	 * @method OauthAccess find_by_hook_name_and_hook_instance_and_user_id($hook_name, $hook_instance, $user_id)
	 * @method OauthAccess find_by_refresh_token($code)
	 * @method OauthAccess[]|\XELOS\Framework\Module\Model\ModelCollection find_all_by_user_id_and_expires_at_and_access_token($user_id, array $array, string|array $string)
	 * @method OauthAccess find_by_user_id_and_expires_at_and_access_token($user_id, array $array, string|array $string)
	 * @method OauthAccess find_by_user_id_and_expires_at_and_authorization_code($user_id, array $array, string $auth_code)
	 * @method OauthAccess find_by_expires_at_and_access_token(array $array, string|array $access_token)
	 * @method OauthAccess find_by_expires_at_and_access_token_and_authorization_code(array $array, string|array $string, $code)
	 */
	class OauthAccess extends \XELOS\Framework\Module\Model\Model
	{

		 
		protected $model_version;

		 
		protected $table_auto_properties;

		 
		protected $table_name;

		 
		protected $table_use_group_id;



		/**
		 * Class xmodel_webservice_oauth_access
		 *
		 * @package XELOS\Modules\Webservice\Model
		 *
		 * @property string     access_token
		 * @property int        expires_at
		 * @property string     authorization_code
		 * @property string     scope
		 * @property int|string user_id if is -1 is general account
		 * @property string     hook_name
		 * @property string     hook_instance
		 * @property string     oauth_data
		 * @property string     refresh_token
		 * @property int        system_user_device_id
		 * @property int      updated_at
		 *
		 * @method OauthAccess find_by_id($id)
		 * @method OauthAccess find_by_hook_name_and_hook_instance_and_user_id($hook_name, $hook_instance, $user_id)
		 * @method OauthAccess find_by_refresh_token($code)
		 * @method OauthAccess[]|\XELOS\Framework\Module\Model\ModelCollection find_all_by_user_id_and_expires_at_and_access_token($user_id, array $array, string|array $string)
		 * @method OauthAccess find_by_user_id_and_expires_at_and_access_token($user_id, array $array, string|array $string)
		 * @method OauthAccess find_by_user_id_and_expires_at_and_authorization_code($user_id, array $array, string $auth_code)
		 * @method OauthAccess find_by_expires_at_and_access_token(array $array, string|array $access_token)
		 * @method OauthAccess find_by_expires_at_and_access_token_and_authorization_code(array $array, string|array $string, $code)
		 */
		public function can_read(){}

		/**
			 * Check OAuth Authorization Code
			 *
			 * @param mixed $code
			 *
			 * @return OauthAccess|false
			 */
		public function check_authorization_code($code){}

		/**
			 * Check OAuth Authorization Code
			 *
			 * @param mixed $code
			 *
			 * @return OauthAccess|false
			 */
		public function check_refresh_token($code){}

		/**
			 * @param $hook_name
			 * @param $hook_instance
			 * @param $user_id
			 *
			 * @return OauthAccess
			 */
		public function exists($hook_name, $hook_instance, $user_id){}

		/**
			 * @param $oauth_data
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OAuthClient
			 * @throws \InvalidArgumentException
			 */
		public function get_client_from_oauth_data($oauth_data){}

		/**
			 * @param int $user_id - Use OAuthClient::GENERAL_ADMIN_MODE for system accounts
			 *
			 * @return string
			 */
		public function get_connected_accounts_sql($user_id = 'XELOS\\Modules\\Webservice\\Lib\\OAuthClient::GENERAL_ADMIN_MODE'){}

		/**
			 * @param $hook_name
			 * @param $hook_instance
			 * @param $user_id
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OAuthClient
			 * @throws \InvalidArgumentException
			 */
		public function get_oauth_client($hook_name, $hook_instance, $user_id){}

		/**
			 * @param $oauth_access_id
			 *
			 * @return \XELOS\Modules\Webservice\Lib\OAuthClient
			 * @throws \InvalidArgumentException
			 */
		public function get_oauth_client_by_id($oauth_access_id){}

		/**
			 * @return bool|int|null
			 * @throws \Exception
			 */
		public function save(){}

	}
} 

namespace XELOS\Modules\Webservice\Page{

	/**
	 * Class AuthorizePage
	 * @package XELOS\Modules\Webservice\Page
	 */
	class AuthorizePage extends \XELOS\Framework\Module\Page\Page
	{

		/**
			 * @var \XELOS\Modules\Webservice\WebserviceController
			 */
		public $mod;



		/**
			 * Wrapper for OAuth authentication flows which end on this public page
			 * XELOS is acting as OAuth client (via oauth_client hook)
			 *
			 * @return string
			 * @throws ContentException
			 */
		public function page_client(){}

		/**
			 * Wrapper for OAuth authentication flows which end on this public page
			 * XELOS is acting as OAuth server
			 *
			 * @return string
			 * @throws ContentException
			 */
		public function page_overview(){}

	}

	/**
	 * @title Webservice JSON-RPC 2.0
	 * @desc http://www.jsonrpc.org/specification
	 */
	class JsonPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var int */
		private $last_request_id;

		/** @var \XELOS\Modules\Webservice\WebserviceController */
		public $mod;



		/**
			 * JSON-RPC Error
			 *
			 * @param string $message A String providing a short description of the error. The message SHOULD be limited to a
			 *                        concise single sentence.
			 * @param int    $code    A Number that indicates the error type that occurred. This MUST be an integer.
			 * @param mixed  $data    A Primitive or Structured value that contains additional information about the error. This
			 *                        may be omitted. The value of this member is defined by the Server (e.g. detailed error
			 *                        information, nested errors etc.).
			 *
			 * @return string JSON Format
			 */
		private function get_json_error($message, $code = -32603, $data = false){}

		/**
			 * @param bool $instance
			 *
			 * @return bool|false|string|\XELOS\Framework\Core\Template
			 * @throws \ReflectionException
			 */
		public function get_page($instance = false){}

		/**
			 * @desc     Pass a REST Service Request to specific Module and return
			 *
			 * @param string $instance_id
			 * @param string $method_name Function name containing module name, hook name and method name
			 * @param array  $parameters
			 *
			 * @return string An empty string, since the output is already written to the stdout
			 * @throws Exception
			 */
		private function invoke_instance_method($instance_id, $method_name, $parameters){}

		/**
			 * JSON Documentation based on SOAP Services
			 *
			 * @param mixed $instance
			 *
			 * @return \XELOS\Framework\Core\Template
			 * @throws \ReflectionException
			 */
		public function page_json_docs($instance = false){}

	}

	class OAuthAccountsPage extends \XELOS\Framework\Module\Page\Page
	{

		/** @var \XELOS\Modules\Webservice\WebserviceController */
		public $mod;

		/**
			 * Default Redirect URL for OAuth Flows
			 * @var string Default: current page
			 */
		private $redirect_url;

		/**
			 * Are we displaying the accounts for the current user (personal settings) or the global accounts?
			 * @var bool
			 */
		private $showUserAccounts;



		public function init(){}

		/**
			 * @return bool
			 */
		public function isShowUserAccounts(){}

		/**
			 * @param string $hook_identifier 'hook_instance.hook_name'
			 *
			 * @return \XELOS\Framework\Core\Template|\xelos_global_template
			 * @throws \XELOS\Framework\Core\Exception\ContentException
			 *
			 */
		public function page_modal($hook_identifier){}

		/**
			 * Overview table with accounts
			 *
			 * @return \XELOS\Framework\Core\Template
			 * @throws Exception
			 */
		public function page_overview(){}

		/**
			 * @param bool $showUserAccounts
			 */
		public function setShowUserAccounts($showUserAccounts){}

	}
} 

